/* $Id: contrib.js 5 2006-11-27 06:25:58Z troyronda $ */

// Code pilfered from other extensions

///////////////////////////////////////////////////////////////////////////////
// From SearchStatus
// not sure about this SearchStatus's copyright...
// if there is a copyright issue here, then we  need to translate
// from some public domain PHP code... BTW, that's where this code
// originally came from...
function iTrustPage_googlechcalc()
{
  return this; 
}

iTrustPage_googlechcalc.prototype =
{
  googleNewCh: function( ch )
  {
  	ch = ( ( ( ch / 7 ) << 2 ) | ( ( this.myfmod( ch,13 ) ) & 7 ) );
  
  	prbuf = new Array();
  	prbuf[0] = ch;
  	for( i = 1; i < 20; i++ ) 
  	{
      prbuf[i] = prbuf[i-1] - 9;
  	}
  	ch = this.googleCH( this.c32to8bit( prbuf ), 80 );
  	
  	return ch;		
  },

  googleCH: function( url ) 
  {
		var init = 0xE6359A60;
		
		var length = url.length;
		
		var a = 0x9E3779B9;
		var b = 0x9E3779B9;
		var c = 0xE6359A60;
		var k = 0;
		var len = length;
		var mixo = new Array(); 
				
		while( len >= 12 ) 
		{
			a += (url[k+0] +(url[k+1]<<8) +(url[k+2]<<16) +(url[k+3]<<24));
			b += (url[k+4] +(url[k+5]<<8) +(url[k+6]<<16) +(url[k+7]<<24));
			c += (url[k+8] +(url[k+9]<<8) +(url[k+10]<<16)+(url[k+11]<<24));
			mixo = this.mix(a,b,c);
			a = mixo[0]; b = mixo[1]; c = mixo[2];
			k += 12;
			len -= 12;
		}
		
		c += length;
		
		switch( len ) 
		{
			case 11:
			c += url[k+10]<<24;
			
			case 10: 
			c+=url[k+9]<<16;
			
			case 9 : 
			c+=url[k+8]<<8;
			
			case 8 : 
			b+=(url[k+7]<<24);
			
			case 7 : 
			b+=(url[k+6]<<16);
			
			case 6 : 
			b+=(url[k+5]<<8);
			
			case 5 : 
			b+=(url[k+4]);
			
			case 4 : 
			a+=(url[k+3]<<24);
			
			case 3 : 
			a+=(url[k+2]<<16);
			
			case 2 : 
			a+=(url[k+1]<<8);
			
			case 1 : 
			a+=(url[k+0]);
		}
		
		mixo = this.mix( a, b, c );
		
		if( mixo[2] < 0 )
		{
			return ( 0x100000000 + mixo[2] );
		}
	  else
	  {
			return mixo[2];
		}
  },

  hexdec: function( str )
  {
  	return parseInt( str, 16 );
  },
  
  zeroFill: function( a, b )
  {
  	var z = this.hexdec( 80000000 );
  	
  	if( z & a )
  	{
  		a = a >> 1;
  		a &= ~z;
  		a |= 0x40000000;
  		a = a >> ( b - 1 );
  	} 
  	else
  	{
  		a = a >> b;
  	}
  	
  	return (a);
  },
  
  mix: function( a, b, c ) 
  {
  	a -= b; a -= c; a ^= ( this.zeroFill( c, 13 ) );
  	b -= c; b -= a; b ^= ( a << 8 );
  	c -= a; c -= b; c ^= ( this.zeroFill( b, 13 ) );
  	a -= b; a -= c; a ^= ( this.zeroFill( c, 12 ) );
  	b -= c; b -= a; b ^= ( a << 16);
  	c -= a; c -= b; c ^= ( this.zeroFill( b, 5 ) );
  	a -= b; a -= c; a ^= ( this.zeroFill( c, 3 ) ); 
  	b -= c; b -= a; b ^= ( a << 10);
  	c -= a; c -= b; c ^= ( this.zeroFill( b, 15 ) );
  	
  	var ret = new Array( (a), (b), (c) );
  	
  	return ret;
  },

  strord: function( string ) 
  {
  	var result = new Array();
  	for( i = 0; i < string.length; i++ ) 
  	{
  		result[i] = string[i].charCodeAt( 0 );
  	}
  	
  	return result;
  },
  
  c32to8bit: function( arr32 ) 
  {
    var arr8 = new Array();	
    
    for( i = 0; i < arr32.length; i++ ) 
    {
    	for( bitOrder = i * 4; bitOrder <= i * 4 + 3; bitOrder++ ) 
    	{
        arr8[bitOrder] = arr32[i] & 255;
        arr32[i] = this.zeroFill( arr32[i], 8 );
      }
    }
    
    return arr8;
  },
  
  myfmod: function( x, y )
  {
  	var i = Math.floor( x / y );
    return ( x - i * y );
  }
};

// Searchstatus globals
var giTrustPageGoogleCHCalc = new iTrustPage_googlechcalc();


//////////////////////////////////////////////////////////////////////////////
// from: http://www.movable-type.co.uk/scripts/SHA-1.html
// See below for the source code of the JavaScript implementation. You are welcome to re-use these scripts [without any warranty express or implied] provided you retain my copyright notice and when possible a link to my website. If you have any queries or find any problems, please contact me.
//  2002-2005 Chris Veness 

_iTrustPage_sha1 = function() { 

/* TR07: I had to add caching to improve performance */
this.hashCache_Msg = new Array ();
this.hashCache_Result = new Array ();
this.hashCache_Max = 50; /* not sure if this is the optimal size or not */

this.sha1HashCache = function (msg){
   for (var i=0;i < this.hashCache_Msg.length; ++i){
	   if (this.hashCache_Msg[i] == msg){
	//	  alert ("sha1HashCache hit: "+msg+": "+this.hashCache_Result[i]);
	      return this.hashCache_Result[i];
       }
   }	
   
   var result = this.sha1Hash (msg);
   
   if (this.hashCache_Msg.length >= this.hashCache_Max && this.hashCache_Msg.length > 0){
	   var shifted_msg = this.hashCache_Msg.shift();
	   var shifted_result = this.hashCache_Result.shift();
	   
     //  alert ("sha1HashCache shift: "+shifted_msg+": "+shifted_result);
   }
   
   //alert ("sha1HashCache miss: "+msg+": "+result);
   this.hashCache_Msg.push (msg);
   this.hashCache_Result.push (result);
   
   return result;
}	
	
this.sha1Hash = function(msg)
{
    // constants [4.2.1]
    var K = [0x5a827999, 0x6ed9eba1, 0x8f1bbcdc, 0xca62c1d6];

    // PREPROCESSING 
 
    msg += String.fromCharCode(0x80); // add trailing '1' bit to string [5.1.1]

    // convert string msg into 512-bit/16-integer blocks arrays of ints [5.2.1]
    var l = Math.ceil(msg.length/4) + 2;  // long enough to contain msg plus 2-word length
    var N = Math.ceil(l/16);              // in N 16-int blocks
    var M = new Array(N);
    for (var i=0; i<N; i++) {
        M[i] = new Array(16);
        for (var j=0; j<16; j++) {  // encode 4 chars per integer, big-endian encoding
            M[i][j] = (msg.charCodeAt(i*64+j*4)<<24) | (msg.charCodeAt(i*64+j*4+1)<<16) | 
                      (msg.charCodeAt(i*64+j*4+2)<<8) | (msg.charCodeAt(i*64+j*4+3));
        }
    }
    // add length (in bits) into final pair of 32-bit integers (big-endian) [5.1.1]
    M[N-1][14] = ((msg.length-1) >>> 30) * 8;
    M[N-1][15] = ((msg.length-1)*8) & 0xffffffff;

    // set initial hash value [5.3.1]
    var H0 = 0x67452301;
    var H1 = 0xefcdab89;
    var H2 = 0x98badcfe;
    var H3 = 0x10325476;
    var H4 = 0xc3d2e1f0;

    // HASH COMPUTATION [6.1.2]

    var W = new Array(80); var a, b, c, d, e;
    for (var i=0; i<N; i++) {

        // 1 - prepare message schedule 'W'
        for (var t=0;  t<16; t++) W[t] = M[i][t];
        for (var t=16; t<80; t++) W[t] = this.ROTL(W[t-3] ^ W[t-8] ^ W[t-14] ^ W[t-16], 1);

        // 2 - initialise five working variables a, b, c, d, e with previous hash value
        a = H0; b = H1; c = H2; d = H3; e = H4;

        // 3 - main loop
        for (var t=0; t<80; t++) {
            var s = Math.floor(t/20); // seq for blocks of 'f' functions and 'K' constants
            var T = (this.ROTL(a,5) + this.f(s,b,c,d) + e + K[s] + W[t]) & 0xffffffff;
            e = d;
            d = c;
            c = this.ROTL(b, 30);
            b = a;
            a = T;
        }

        // 4 - compute the new intermediate hash value
        H0 = (H0+a) & 0xffffffff;  // note 'addition modulo 2^32'
        H1 = (H1+b) & 0xffffffff; 
        H2 = (H2+c) & 0xffffffff; 
        H3 = (H3+d) & 0xffffffff; 
        H4 = (H4+e) & 0xffffffff;
    }

    return H0.toHexStr() + H1.toHexStr() + H2.toHexStr() + H3.toHexStr() + H4.toHexStr();
}

//
// function 'f' [4.1.1]
//
this.f = function(s, x, y, z) 
{
    switch (s) {
    case 0: return (x & y) ^ (~x & z);
    case 1: return x ^ y ^ z;
    case 2: return (x & y) ^ (x & z) ^ (y & z);
    case 3: return x ^ y ^ z;
    }
};

//
// rotate left (circular left shift) value x by n positions [3.2.5]
//
this.ROTL = function(x, n)
{
    return (x<<n) | (x>>>(32-n));
};

};

//
// extend Number class with a tailored hex-string method 
//   (note toString(16) is implementation-dependant, and 
//   in IE returns signed numbers when used on full words)
//
Number.prototype.toHexStr = function()
{
    var s=""
    var v;
    for (var i=7; i>=0; i--) { v = (this>>>(i*4)) & 0xf; s += v.toString(16); }
    return s;
};


var iTrustPage_sha1 = new _iTrustPage_sha1();
