/* $Id: trustBlock.js 21 2007-02-01 22:57:44Z troyronda $ */

/* iTrustPage
 * Copyright (c) 2006 Troy Ronda and the University of Toronto.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


 
var TrustBlock = {
  linkList: null,
  linkIndex: 0,
  initialized: false,
//  nextSearchDelay: 0,
  
  onLoad: function(e) {
    if (this.initialized)
       return;    

    TrustBlock.loadedPreviewCount = 0;
    TrustBlock.loadedOriginal = false;
    TrustBlock.maxPreview = 2;
//    TrustBlock.maxPreviewBox = 10;
    TrustBlock.maxPreviewBox = 3;      
     
    var frameo = document.getElementById("browser-original-page");   
       
    var box1 = document.getElementById("TrustBlock-Content_Top1");
    var box2 = document.getElementById("TrustBlock-Content_Top2");
    var box3 = document.getElementById("TrustBlock-Content_Top3");
/*    var box4 = document.getElementById("TrustBlock-Content_Top4");
    var box5 = document.getElementById("TrustBlock-Content_Top5");
    var box6 = document.getElementById("TrustBlock-Content_Top6");
    var box7 = document.getElementById("TrustBlock-Content_Top7");
    var box8 = document.getElementById("TrustBlock-Content_Top8");
    var box9 = document.getElementById("TrustBlock-Content_Top9");
    var box10 = document.getElementById("TrustBlock-Content_Top10");*/
    
    TrustBlock.boxList = new Array();
    TrustBlock.boxList.push(box1);
    TrustBlock.boxList.push(box2);
    TrustBlock.boxList.push(box3);
  /*  TrustBlock.boxList.push(box4);
    TrustBlock.boxList.push(box5);
    TrustBlock.boxList.push(box6);
    TrustBlock.boxList.push(box7);
    TrustBlock.boxList.push(box8);
    TrustBlock.boxList.push(box9);
    TrustBlock.boxList.push(box10);
    */
    var frame1 = document.getElementById("TrustBlock-Content-Body_Top1");
    var frame2 = document.getElementById("TrustBlock-Content-Body_Top2");
    var frame3 = document.getElementById("TrustBlock-Content-Body_Top3");
/*    var frame4 = document.getElementById("TrustBlock-Content-Body_Top4");
    var frame5 = document.getElementById("TrustBlock-Content-Body_Top5");
    var frame6 = document.getElementById("TrustBlock-Content-Body_Top6");
    var frame7 = document.getElementById("TrustBlock-Content-Body_Top7");
    var frame8 = document.getElementById("TrustBlock-Content-Body_Top8");
    var frame9 = document.getElementById("TrustBlock-Content-Body_Top9");
    var frame10 = document.getElementById("TrustBlock-Content-Body_Top10");*/
       
    TrustBlock.frameList = new Array();
    TrustBlock.frameList.push(frame1);
    TrustBlock.frameList.push(frame2);
    TrustBlock.frameList.push(frame3);
/*    TrustBlock.frameList.push(frame4);
    TrustBlock.frameList.push(frame5);
    TrustBlock.frameList.push(frame6);
    TrustBlock.frameList.push(frame7);
    TrustBlock.frameList.push(frame8);
    TrustBlock.frameList.push(frame9);
    TrustBlock.frameList.push(frame10);
    
    
*/    
    TrustBlock.removeList = new Array();
    TrustBlock.removeList.push(false);
    TrustBlock.removeList.push(false);
    TrustBlock.removeList.push(false);
    
    var text  = document.getElementById("TrustBlock-Tags");
  
    text.addEventListener("keydown",TrustBlock.onKeyDown,true);    
    text.addEventListener("keyup",TrustBlock.onTextChange,true);    

    frameo.addEventListener("pageshow",        function() {
        TrustBlock.loadedOriginal = true;
	    
	    window.clearTimeout(TrustBlock.updateOriginalViewTimeout);
	    TrustBlock.updateOriginalViewTimeout = window.setTimeout(function() {
		    TrustBlock.UpdateOriginalView();
         },0);},true);

//    for (var i=0;i<TrustBlock.maxPreview;i++){
//       TrustBlock.frameList[i].addEventListener("pageshow",function() { TrustBlock.onDocumentPageShow(i) },true);
//    }
    TrustBlock.frameList[0].addEventListener("pageshow",function() { TrustBlock.onDocumentPageShow(0) },true);
    TrustBlock.frameList[1].addEventListener("pageshow",function() { TrustBlock.onDocumentPageShow(1) },true);
    TrustBlock.frameList[2].addEventListener("pageshow",function() { TrustBlock.onDocumentPageShow(2) },true);
/*    TrustBlock.frameList[3].addEventListener("pageshow",function() { TrustBlock.onDocumentPageShow(3) },true);
    TrustBlock.frameList[4].addEventListener("pageshow",function() { TrustBlock.onDocumentPageShow(4) },true);
    TrustBlock.frameList[5].addEventListener("pageshow",function() { TrustBlock.onDocumentPageShow(5) },true);
    TrustBlock.frameList[6].addEventListener("pageshow",function() { TrustBlock.onDocumentPageShow(6) },true);
    TrustBlock.frameList[7].addEventListener("pageshow",function() { TrustBlock.onDocumentPageShow(7) },true);
    TrustBlock.frameList[8].addEventListener("pageshow",function() { TrustBlock.onDocumentPageShow(8) },true);
    TrustBlock.frameList[9].addEventListener("pageshow",function() { TrustBlock.onDocumentPageShow(9) },true);
*/    
    
    TrustBlock.frameList[0].addEventListener("DOMContentLoaded",function() { TrustBlock.onDocumentDOMContentLoaded(0) },true);
    TrustBlock.frameList[1].addEventListener("DOMContentLoaded",function() { TrustBlock.onDocumentDOMContentLoaded(1) },true);
    TrustBlock.frameList[2].addEventListener("DOMContentLoaded",function() { TrustBlock.onDocumentDOMContentLoaded(2) },true);
/*    TrustBlock.frameList[3].addEventListener("DOMContentLoaded",function() { TrustBlock.onDocumentDOMContentLoaded(3) },true);
    TrustBlock.frameList[4].addEventListener("DOMContentLoaded",function() { TrustBlock.onDocumentDOMContentLoaded(4) },true);
    TrustBlock.frameList[5].addEventListener("DOMContentLoaded",function() { TrustBlock.onDocumentDOMContentLoaded(5) },true);
    TrustBlock.frameList[6].addEventListener("DOMContentLoaded",function() { TrustBlock.onDocumentDOMContentLoaded(6) },true);
    TrustBlock.frameList[7].addEventListener("DOMContentLoaded",function() { TrustBlock.onDocumentDOMContentLoaded(7) },true);
    TrustBlock.frameList[8].addEventListener("DOMContentLoaded",function() { TrustBlock.onDocumentDOMContentLoaded(8) },true);
    TrustBlock.frameList[9].addEventListener("DOMContentLoaded",function() { TrustBlock.onDocumentDOMContentLoaded(9) },true);
*/    
    

    for (var i=TrustBlock.maxPreview; i<TrustBlock.maxPreviewBox; i++){     
	   TrustBlock.boxList[i].collapsed=true;   
    }

//alert ("done TrustBlock load");  
       
    this.initialized = true;      
  },
/*  onDocumentDOM: function (ev){
  },*/
  onDocumentPageShow: function (id) {
	  //alert(id);
     var rpt = iTrustPage.getCurrentReport(); 
     var redirectingIcon = document.getElementById("TrustBlock-redirecting-icon");
     var loadingIcon = document.getElementById("TrustBlock-loading-icon");
     
     redirectingIcon.collapsed = true;
     
     if (!rpt.blockShowing)
        return; 
	  

     var frame = TrustBlock.frameList[id];              
     var currentUrl = frame.getAttribute("src"); 
     
     if (currentUrl != "about:blank"){
        TrustBlock.loadedPreviewCount += 1;	     
     }
     
        if (TrustBlock.loadedPreviewCount >= TrustBlock.maxPreview)
           loadingIcon.collapsed = true;
        else
           loadingIcon.collapsed = false;
	  //alert(TrustBlock.loadedPreviewCount);
     
        document.title = "iTrustPage: Protecting against Phishing Attacks";
        window.clearTimeout(iTrustPage.timerTitle);
        iTrustPage.timerTitle = window.setTimeout(
        function() {
	       document.title = "iTrustPage: Protecting against Phishing Attacks";
        }, 500);
 
/*    window.setTimeout(
         function (){TrustBlock.UpdateAllViews(id)},500);*/
         
       TrustBlock.UpdateAllViews(id);

              
  },
  onDocumentDOMContentLoaded: function (id) {
	  
     if (TrustBlock.removeList[id]) { /*alert("already done "+id);*/ return;}
	 //alert ("onDocumentDOMContentLoaded " + id);
     TrustBlock.removeList[id] = true;
     
     var frame = TrustBlock.frameList[id];     
     if (frame.contentDocument.body){
        // remove onload attribute        
        frame.contentDocument.body.removeAttribute("onload")           
        frame.contentDocument.body.removeAttribute("onunload")           
        
	    // remove some tags
        var allTags = frame.contentDocument.getElementsByTagName("bgsound");     
        var num = allTags.length;
        //alert("There are " + num + " <bgsound> elements in this document");
     
        for (var i=0;i<allTags.length;++i){
	       var node = allTags[i];
           if (node.parentNode) {
	           node.parentNode.removeChild(node);       
           }
        }	     	     
        
	    // remove some tags
        var allTags = frame.contentDocument.getElementsByTagName("embed");     
        var num = allTags.length;
        //alert("There are " + num + " <embed> elements in this document");
     
        for (var i=0;i<allTags.length;++i){
	       var node = allTags[i];
           if (node.parentNode) {
	           node.parentNode.removeChild(node);       
           }
        }	     	     

        
	    // remove some tags
        var allTags = frame.contentDocument.getElementsByTagName("iframe");     
        var num = allTags.length;
        //alert("There are " + num + " <iframe> elements in this document");
     
        for (var i=0;i<allTags.length;++i){
	       var node = allTags[i];
           if (node.parentNode) {
	           node.parentNode.removeChild(node);       
           }
        }	     	     

	    // remove some tags
        var allTags = frame.contentDocument.getElementsByTagName("frameset");     
        var num = allTags.length;
        //alert("There are " + num + " <iframe> elements in this document");
     
        for (var i=0;i<allTags.length;++i){
	       var node = allTags[i];
           if (node.parentNode) {
	           node.parentNode.removeChild(node);       
           }
        }	     	     
                
                
	    // remove some tags
        var allTags = frame.contentDocument.getElementsByTagName("script");     
        var num = allTags.length;
        //alert("There are " + num + " <script> elements in this document");
     
        for (var i=0;i<allTags.length;++i){
	       var node = allTags[i];
           if (node.parentNode) {
	           node.parentNode.removeChild(node);       
           }
        }	     	     
        //alert("done");
        
     }
  },  
  UpdateTimer: function (){
   
   for (var i=0; i<TrustBlock.maxPreview; ++i){
	  TrustBlock.UpdateAllViews(i);
   }
   
   window.clearTimeout(TrustBlock.previewTimer);
   
   if (TrustBlock.loadedPreviewCount < TrustBlock.maxPreview){
    TrustBlock.previewTimer = window.setTimeout(
         function (){TrustBlock.UpdateTimer()},500);
   }else{
    TrustBlock.previewTimer = window.setTimeout(
         function (){TrustBlock.UpdateTimer()},2500);   	   
   }
	  
  },
  UpdateAllViews: function (i){
    
     document.title = "iTrustPage: Protecting against Phishing Attacks";
     
     var canvasArray = new Array ("TrustBlock-Content-Body_Canvas_Top1","TrustBlock-Content-Body_Canvas_Top2","TrustBlock-Content-Body_Canvas_Top3","TrustBlock-Content-Body_Canvas_Top4","TrustBlock-Content-Body_Canvas_Top5","TrustBlock-Content-Body_Canvas_Top6","TrustBlock-Content-Body_Canvas_Top7","TrustBlock-Content-Body_Canvas_Top8","TrustBlock-Content-Body_Canvas_Top9","TrustBlock-Content-Body_Canvas_Top10");
     var canvasLabelArray = new Array ("TrustBlock-Content-Body_Label_Top1","TrustBlock-Content-Body_Label_Top2","TrustBlock-Content-Body_Label_Top3","TrustBlock-Content-Body_Label_Top4","TrustBlock-Content-Body_Label_Top5","TrustBlock-Content-Body_Label_Top6","TrustBlock-Content-Body_Label_Top7","TrustBlock-Content-Body_Label_Top8","TrustBlock-Content-Body_Label_Top9","TrustBlock-Content-Body_Label_Top10");
     var canvasBrowserArray = new Array ("TrustBlock-Content-Body_Top1","TrustBlock-Content-Body_Top2","TrustBlock-Content-Body_Top3","TrustBlock-Content-Body_Top4","TrustBlock-Content-Body_Top5","TrustBlock-Content-Body_Top6","TrustBlock-Content-Body_Top7","TrustBlock-Content-Body_Top8","TrustBlock-Content-Body_Top9","TrustBlock-Content-Body_Top10");               
	     
     var scrollbox = document.getElementById("TrustBlock-Preview-Scrollbox");
     
     var canvas = document.getElementById(canvasArray[i]);     
     var canvasLabel = document.getElementById(canvasLabelArray[i]);     
     var canvas_browser = document.getElementById(canvasBrowserArray[i]);     
     var url = canvas_browser.getAttribute("src");
         
     scrollbox.height = TrustBlock.bHeight/2;
     
     if (url != "about:blank"){	     
        TrustBlock.UpdateView(canvas_browser,canvas);
        //TrustBlock.DrawCheck(canvas);
        canvasLabel.value = url + ": " +canvas_browser.contentTitle;
         
       if (canvasLabel.value.length > 30){canvasLabel.value = canvasLabel.value.substr(0,30)+"...";}
    }else{
        TrustBlock.UpdateView(canvas_browser,canvas);
        canvasLabel.value ="Loading...";	   	    
    }
  },  
  UpdateOriginalTimer: function (){
   
   //alert("?");
   TrustBlock.UpdateOriginalView();
   
   window.clearTimeout(TrustBlock.previewOriginalTimer);
   if ( !TrustBlock.loadedOriginal ){
    TrustBlock.previewOriginalTimer = window.setTimeout(
         function (){TrustBlock.UpdateOriginalTimer()},500);
   }else{
    TrustBlock.previewOriginalTimer = window.setTimeout(
         function (){TrustBlock.UpdateOriginalTimer()},2500);   	   
   }
	  
  },  
  UpdateOriginalView: function (){
//         alert ("UpdateOriginalView ");
         var canvas = document.getElementById("preview-original-page");     
         var canvas2 = document.getElementById("preview-original-page2");     
         var canvas_unver = document.getElementById("preview-original-page-unver");     
         var canvas_ver2 = document.getElementById("preview-original-page-ver2");     
         
         var canvas_browser = document.getElementById("browser-original-page");     
         //var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);

    	// get handle to working canvas
	    //var WorkingCanvas = document.getElementById("itrustpage-working-canvas");
                  
         //alert (canvas_browser);
         //var canvas_uri = String(b.contentDocument.location);
                 
         //var url = canvas_browser.getAttribute("src");

         //TrustBlock.UpdateWorkingCanvas(canvas_browser);         
         //TrustBlock.DrawQuestion(WorkingCanvas);  
         
         //TrustBlock.UpdateViewFromCanvas(WorkingCanvas,canvas);
         
         TrustBlock.UpdateView(canvas_browser,canvas);	
         //TrustBlock.DrawQuestion(canvas);           
         
         TrustBlock.UpdateView(canvas_browser,canvas2);	
         //TrustBlock.DrawQuestion(canvas2); 

         
         TrustBlock.UpdateView(canvas_browser,canvas_unver);	
         //TrustBlock.DrawQuestion(canvas_unver);  
          
         TrustBlock.UpdateView(canvas_browser,canvas_ver2);	
//         TrustBlock.DrawCheck(canvas_ver2);  
         
  },
  UpdateView: function (browser, canvas){
	var cWindow = browser.contentWindow;
	
	//alert (cWindow.width + ", " +cWindow.height);
	
	TrustBlock.UpdateViewWindow(cWindow,canvas);
	  
  },
/*  UpdateWorkingCanvas: function (browser){	  
	// based on save_as_image code 
	var cWindow = browser.contentWindow;
    var root = browser.contentDocument.documentElement;

	// get handle to working canvas
	var WorkingCanvas = document.getElementById("itrustpage-working-canvas");
        	
    // Make sure it is a HTML document
	if (root != "[object XPCNativeWrapper [object HTMLHtmlElement]]" && root != "[object HTMLHtmlElement]") {
	   throw 1;
	}
	    
	// Find the window dimensions:
	if (root.offsetHeight > root.scrollHeight) {
	   TrustBlock.height = root.offsetHeight;
    } else {
	   TrustBlock.height = root.scrollHeight;
	}
			
	if (root.offsetWidth > root.scrollWidth) {
	   TrustBlock.width = root.offsetWidth;
	} else {
	   TrustBlock.width = root.scrollWidth;
	}
			
	// Unfortunately there is a limit:
	if (TrustBlock.height > 16384) {
	   TrustBlock.height = 16384;
	}	  
	
    // Setup the canvas:
    WorkingCanvas.removeAttribute("style");
	WorkingCanvas.height = TrustBlock.height;
	WorkingCanvas.width = TrustBlock.width;
				  
	var ctx = WorkingCanvas.getContext("2d");
	//alert (ctx);
	ctx.drawWindow(cWindow, 0, 0, TrustBlock.width, TrustBlock.height, "rgb(255,255,255)");		
    WorkingCanvas.setAttribute("style","display:none");
		  
  },
  UpdateViewFromCanvas: function(OriginalCanvas, canvas){		  
	  //alert ("UpdateViewFromCanvas");
	  
	var w = OriginalCanvas.width;
	var h = OriginalCanvas.height;
	
	var canvasW = canvas.width;
	var canvasH = canvas.height;
		
    var scaleRatioX = canvasW/w;
    var scaleRatioY = canvasH/h;
    
    if (scaleRatioX > 1){scaleRatioX = 1;}
    if (scaleRatioY > 1){scaleRatioY = 1;}
		
    //alert (scaleRatioX);
    //alert (scaleRatioY);
    
    //if (scaleRatioX < scaleRatioY){scaleRatioY=scaleRatioX;}
    //if (scaleRatioY < scaleRatioX){scaleRatioX=scaleRatioY;}
    
	var ctx = canvas.getContext("2d");
	ctx.clearRect(0, 0, canvasW, canvasH);
	ctx.save();
	ctx.scale(scaleRatioX, scaleRatioY);
	
	ctx.drawImage(OriginalCanvas, 0, 0);		
	ctx.restore();
	
  },  */
  UpdateViewWindow: function(cWindow, canvas){		  
	var w = TrustBlock.bWidth;
	var h = TrustBlock.bHeight;
	
//	alert ("h is "+h);
	
	//var w = cWindow.innerWidth + cWindow.scrollMaxX;
	//var h = cWindow.innerHeight + cWindow.scrollMaxY;
	if (w > 1050) w = 1050;
//	if (w > 1280) w = 1280;
	if (h > 1024) h = 1024;
	
	//if (w > 800) w = 800;
	//if (h > 400) h = 400;
	
	canvas.style.width = (w/3)+"px" ;
	canvas.style.height = (h/3)+"px";
	canvas.width = (w/3);
	canvas.height = (h/3);
	
	var canvasW = canvas.width;
	var canvasH = canvas.height;
		
	//alert (canvasW +","+canvasH);
	
    //var scaleRatioX = 1;
    //var scaleRatioY = 1;
//    var scaleRatioX = canvasW/w;
//    var scaleRatioY = canvasH/h;
    
    //if (scaleRatioX > 1){scaleRatioX = 1;}
    //if (scaleRatioY > 1){scaleRatioY = 1;}
		
    //if (scaleRatioX < scaleRatioY){scaleRatioY=scaleRatioX;}
    //if (scaleRatioY < scaleRatioX){scaleRatioX=scaleRatioY;}
    
	var ctx = canvas.getContext("2d");
	ctx.clearRect(0, 0, canvasW, canvasH);
	//ctx.save();
	//ctx.scale(scaleRatioX, scaleRatioY);
	
	//alert (cWindow+" "+w+" "+h);
	
	//ctx.drawWindow(cWindow, cWindow.scrollX, cWindow.scrollY, w+cWindow.scrollX, h+cWindow.scrollY, "rgb(255,255,255)");		
	ctx.drawWindow(cWindow, 0, 0, w, h, "rgb(255,255,255)");		
	//ctx.restore();
	
  },  
  ShowLargePreview: function(ev, browser){
     var canvas_browser = document.getElementById(browser);   
     var cWindow = canvas_browser.contentWindow;
     
//     var canvas = document.getElementById("iTrustPage-Preview-Large-Canvas");
//     var popup = document.getElementById("iTrustPage-Preview-Large-Popup");
     //var dialog = document.getElementById("iTrustPage-Preview-Large-Dialog");
  	/* render the entire page */
//	var w = cWindow.innerWidth + cWindow.scrollMaxX;
//	var h = cWindow.innerHeight + cWindow.scrollMaxY;
	  var w = TrustBlock.bWidth;
	  var h = TrustBlock.bHeight;
     
//	 canvas.style.width = w+"px";
//	 canvas.style.height = h+"px";
//	 canvas.width = w;
//	 canvas.height = h;
  	 //popup.showPopup (ev.target,0,0,"popup","topleft","topleft");
  	 
  	 openDialog("chrome://itrustpage/content/trustPreviewLarge.xul", "dlg", "dialog=no,minimize=no,modal=yes,resizable=yes,height="+2*h/3+",width="+2*w/3+"", canvas_browser, cWindow);
  /*
	 var scaleRatioX = 1;
     var scaleRatioY = 1;
 	 var canvasW = canvas.width;
	 var canvasH = canvas.height;
		
	 	 
	var ctx = canvas.getContext("2d");
	ctx.clearRect(0, 0, canvasW, canvasH);
	//ctx.save();
	//ctx.scale(scaleRatioX, scaleRatioY);
	
	ctx.drawWindow(cWindow, 0, 0, w, h, "rgb(255,255,255)");		
	//ctx.restore();
	*/ 
  },
  DrawQuestion: function (canvas){
	  
	var ctx = canvas.getContext("2d");
    var img = new Image();
    img.onload = function(){
      ctx.drawImage(img,103,5);
      ctx.beginPath();
      ctx.stroke();
    }
    img.src = 'chrome://itrustpage/skin/questionmark.png';
    	  
  },
  DrawCheck: function (canvas){
	  
	var ctx = canvas.getContext("2d");
    var img = new Image();
    img.onload = function(){
      ctx.drawImage(img,93,5);
      ctx.beginPath();
      ctx.stroke();
    }
    img.src = 'chrome://itrustpage/skin/checkmark.png';
    	  
  },
  onDocumentFocus: function (ev) {
  },  
  onDocumentMouse: function (ev) {
     TrustBlock.doInteractionCheckFromEvent(ev);
  },
  onDocumentKeyboardEvent: function (ev) {
     if (ev.altKey || ev.ctrlKey)
        return;
         
     if (ev.charCode == 0 || ev.charCode == 32)
        return;
        
     if (!this.linkList)
        return;   
           
     iTrustPageCache.appendFoundURI(this.linkList[this.linkIndex],false);
     //iTrustPageWhitelist.addUri(TrustBlock.linkList[TrustBlock.linkIndex]); 
     getBrowser().loadURI(TrustBlock.linkList[TrustBlock.linkIndex]);
          
     TrustBlock.hideBlock();               
  },
  doInteractionCheckFromEvent: function (ev){
     if (ev.target && ev.target.tagName &&
         (ev.target.tagName.toLowerCase() == "textbox" ||
          ev.target.tagName.toLowerCase() == "input" ||
          ev.target.tagName.toLowerCase() == "select" ||
          ev.target.tagName.toLowerCase() == "textarea" ||
          ev.target.tagName.toLowerCase() == "button"
        )){         
 
        //iTrustPageWhitelist.addUri(TrustBlock.linkList[TrustBlock.linkIndex]); 
        iTrustPageCache.appendFoundURI(this.linkList[this.linkIndex],false);
        
        getBrowser().loadURI(TrustBlock.linkList[TrustBlock.linkIndex]);
          
        TrustBlock.hideBlock();               
    }       
  },
  showBlock: function() {
     getBrowser().setAttribute('wait-cursor',true);

    window.clearTimeout(this.hideBlockTimer);
    // grab handles
    //var frame = document.getElementById("TrustBlock-Content-Body");

    var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
    var block = document.getElementById("itrustpage-trustblock-box");                
    var tabbrowser = document.getElementById ("content");
    var text  = document.getElementById("TrustBlock-Tags");
    
    var btnOk = document.getElementById("TrustBlock-okbutton");
    var btnNext = document.getElementById("TrustBlock-nextbutton");
    var btnPrev = document.getElementById("TrustBlock-prevbutton");
    var btnFound = document.getElementById("TrustBlock-foundbutton");
    var btnBack  = document.getElementById("TrustBlock-backbutton");
    var boxFound = document.getElementById("TrustBlock-found-box");
    var btnCont = document.getElementById("TrustBlock-contbutton");
    var btnCont2 = document.getElementById("TrustBlock-contbutton2");
    var boxExtraInfo = document.getElementById("TrustBlock-Extra-Information");
    
    /*
    if (iTrustPageMain.enableBlockExtraInformation) boxExtraInfo.collapsed = false;
    else boxExtraInfo.collapsed = true;
    */
    
    var tabcontainer = document.getElementById("content");
    tabcontainer.tabContainer.collapsed = true;

    /* find the dimensions of the window after loading */
    var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
	var cWindow = b.contentWindow;
	//var cWindow = content.window;
	
	if (cWindow.innerWidth == 0 && TrustBlock.bWidth > 0);
	else if (cWindow.innerWidth > 250)
    	TrustBlock.bWidth = cWindow.innerWidth;
    else
    	TrustBlock.bWidth = 250;
	
	if (cWindow.innerHeight == 0 && TrustBlock.bHeight > 0);
	else if (cWindow.innerHeight > 250)
	    TrustBlock.bHeight = cWindow.innerHeight;
	else
	    TrustBlock.bHeight = 250;
            
    var rpt = iTrustPage.getCurrentReport();
    if (rpt.blockShowing){
        block.collapsed=false;
        getBrowser().removeAttribute('wait-cursor');
        return;            
    }         
    
    var cmd_back = document.getElementById("Browser:Back");
    cmd_back.setAttribute("disabled","true");

    /*    
    if (iTrustPageMain.enableBlockExtraInformation)
       this.doQueryCategoryForBlock();

    */   
    if (document.title != "iTrustPage: Protecting against Phishing Attacks")
       rpt.blockTitle = document.title;
 
    rpt.blockShowing = true;
    iTrustPageLog.appendBlockShowEvent(rpt);
    iTrustPage.setMemoryCachedReport(rpt);	  
   

    // initialization code    
    this.currentURI = rpt.currentURI;
    this.currentDomain = rpt.currentDomain;
    this.firstDomain = rpt.firstDomain;
    this.firstDomainURI = rpt.firstDomainURI;
 
    //alert (document.title);  
    //b.collapsed=true;
    iTrustPageMain.notificationHide();
    block.collapsed=false;
//          alert ("showing block");

        var cmd_back = document.getElementById("Browser:Back");
        cmd_back.removeAttribute("disabled");     
        
    ///////////////////////////////////////////////////////////////////////////////////////
    // update original canvas image
  //  alert ("showing block");
         var canvas_browser = document.getElementById("browser-original-page");     
         
         //canvas_browser.stop();
         //canvas_browser.setAttribute('src',"about:blank");
         //window.setTimeout(function (){
         //TrustBlock.UpdateOriginalView();//},50);
    
         var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
         var canvas_uri = document.getElementById("url-original-page");     
         var canvas_uri2 = document.getElementById("url-original-page2");     
         var canvas_uri_unver = document.getElementById("url-original-page-unver");     
         var canvas_uri_ver2 = document.getElementById("url-original-page-ver2");              
         
         var uri = String(b.contentDocument.location);
         canvas_browser.setAttribute('src',uri);
         //TrustBlock.UpdateOriginalView();
         TrustBlock.loadedOriginal = false;
         
         window.clearTimeout(TrustBlock.previewOriginalTimer);
         TrustBlock.previewOriginalTimer = window.setTimeout(function (){
         TrustBlock.UpdateOriginalTimer();},0);
         //TrustBlock.UpdateOriginalTimer();
  
         canvas_uri.value = uri;         
         if (canvas_uri.value.length > 30){canvas_uri.value = canvas_uri.value.substr(0,30)+"...";}

         canvas_uri2.value = canvas_uri.value;         
         canvas_uri_unver.value = canvas_uri.value;         
//         canvas_uri_ver.value = canvas_uri.value;         
         canvas_uri_ver2.value = canvas_uri.value;         
    
    /////////////////////////////////////////////////////////////////////////////////////////

    
    // clear state
    text.value = rpt.tagString;
    
    if (text.value == "")
       text.value = "Enter Search Keywords Here";
    
    //frame.setAttribute('src',rpt.linkURI);
    this.linkList = rpt.linkList;     
    this.linkIndex = rpt.linkIndex;
//alert ("c");
       

    // hide the results screen
    if (rpt.linkList.length == 0)
       boxFound.collapsed=true;
    else
       boxFound.collapsed=false;
    
    var text  = document.getElementById("TrustBlock-Tags");
    text.blur();
//        text.focus();
//        text.select();
//    text.disabled=true; /* let the user stop typing first :-) */

//alert ("b");
    window.clearTimeout(TrustBlock.TagSelectionTimer);
    TrustBlock.TagSelectionTimer = window.setTimeout(
     function() {
        var text  = document.getElementById("TrustBlock-Tags");
        text.disabled=false;
        text.focus();
        text.select();
     }, 1500);
     
    // make the browser message persistent.
    //iTrustPageMain.setNotificationPersist(true);

//    this.nextSearchDelay = iTrustPageMain.blockInitialSearchDelay;

//    rpt.searchIsNew = false; 
//    btnOk.disabled=true;     
//    btnCont.disabled=true
//    window.clearTimeout(this.enableSearchBtn);
//     this.enableSearchBtn = window.setTimeout(
//     function() {
//        TrustBlock.tryToEnableSearch();
//     }, 1000 * this.nextSearchDelay);
//alert ("a");

     var searchBox = document.getElementById("itrustpage-block-search-box");  
     searchBox.collapsed = false;     
     var boxFound = document.getElementById("TrustBlock-found-box");
     boxFound.collapsed = true;     
     var boxVerify = document.getElementById("TrustBlock-verify-box");
     boxVerify.collapsed = true;     
     var boxVerifyAuto = document.getElementById("TrustBlock-verify-box-auto");
     boxVerifyAuto.collapsed = true;     
     var boxIgnore = document.getElementById("TrustBlock-ignore-box");
     boxIgnore.collapsed = true;     
     
    TrustBlock.refreshInformation();     
    
    getBrowser().removeAttribute('wait-cursor');

     document.title = "iTrustPage: Protecting against Phishing Attacks";
     window.clearTimeout(iTrustPage.timerTitle);
     iTrustPage.timerTitle = window.setTimeout(
     function() {
	    document.title = "iTrustPage: Protecting against Phishing Attacks";
     }, 200);
    
  
  },
  refreshInformation: function(){
	  /*
    var rpt = iTrustPage.getCurrentReport();
    var btnCont = document.getElementById("TrustBlock-contbutton");
    var btnCont2 = document.getElementById("TrustBlock-contbutton2");


    var remainingSearchCount = rpt.totalSearches-rpt.searchAttemptCount;
    if (iTrustPageMain.blockAllowBypass && remainingSearchCount <= 0){
       remainingSearchCount = 0;
       btnCont.collapsed=false;
       btnCont2.collapsed=false;
       
       btnCont.disabled=false;
       btnCont2.disabled=false;
       
    }
    else {
       btnCont.collapsed=true;    
       btnCont2.collapsed=true;    
       
       btnCont.disabled=true;
       btnCont2.disabled=true;       
    }
    */
  },
  hideBlockDelay: function (){
    window.clearTimeout(this.hideBlockTimer);
     this.hideBlockTimer = window.setTimeout(
     function() {
        TrustBlock.hideBlock(); 
     }, 1000);

  }, 
  hideBlockSmallDelay: function (){
    window.clearTimeout(this.hideBlockTimer);
     this.hideBlockTimer = window.setTimeout(
     function() {
        TrustBlock.hideBlock(); 
     }, 200);

  }, 
  hideBlock: function (){ 


	  	  
     var rpt = iTrustPage.getCurrentReport(); 
     //var frame = document.getElementById("TrustBlock-Content-Body");

    var tabcontainer = document.getElementById("content");
    tabcontainer.tabContainer.collapsed = false;
     
     window.clearTimeout(this.hideBlockTimer);
     if (!rpt.blockShowing){
        var block = document.getElementById ("itrustpage-trustblock-box");
        block.collapsed=true;
        getBrowser().removeAttribute('wait-cursor');
        return;            
     }  
     
     var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
     if (b.canGoBack){
        var cmd_back = document.getElementById("Browser:Back");
        cmd_back.removeAttribute("disabled");     
     }else{
        var cmd_back = document.getElementById("Browser:Back");
        cmd_back.setAttribute("disabled","true");     	     
     }
/*     
          var uri = String(b.contentDocument.location);
   	      var urlbar = document.getElementById("urlbar");
   	      urlbar.value = uri;
  */   
     
     iTrustPageLog.appendBlockHideEvent(rpt);
                 
     window.clearTimeout(TrustBlock.previewOriginalTimer);
     window.clearTimeout(TrustBlock.previewTimer);
     window.clearTimeout(iTrustPage.timerTitle);
                
     
     for (var i=0;i<TrustBlock.maxPreview;i++){   
	   TrustBlock.frameList[i].stop();    
       TrustBlock.frameList[i].setAttribute('src','about:blank');          
     }     
     //alert (rpt.blockTitle);
       
//     alert (rpt.blockTitle);
     if (rpt.blockTitle && rpt.blockTitle != ""){
        document.title = rpt.blockTitle;
        // alert (document.title);
        
               window.clearTimeout(TrustBlock.ReportTitleTimer)
               TrustBlock.ReportTitleTimer = window.setTimeout(
               function() {
                  var rpt = iTrustPage.getCurrentReport();
	              document.title = rpt.blockTitle;
               }, 100);
        
     }
	  
	 // grab handles
     var block = document.getElementById ("itrustpage-trustblock-box");
     var tabbrowser = document.getElementById ("content");
     var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
     
     var canvas_browser = document.getElementById("browser-original-page");     
         
     canvas_browser.stop();
     canvas_browser.setAttribute('src',"about:blank");
     
     
     //b.collapsed=false;    
     block.collapsed=true;

     rpt.recheck();

     rpt.blockShowing = false;                        
     
     iTrustPage.updateStatusbar();
//     iTrustPageMain.setNotificationPersist(false);   
     getBrowser().removeAttribute('wait-cursor');         
     
  }, 
  goBack: function (e) {

     var rpt = iTrustPage.getCurrentReport();
     iTrustPageLog.appendBlockCancelEvent(rpt);
     TrustBlock.hideBlock();               

  },	  
  btnCont: function (e) {
/*	  
     var rpt = iTrustPage.getCurrentReport();

     var clearOK = confirm ("Do you wish to proceed to fill the form?\n\nWarning -- it is possible the form you intend to fill will use your information maliciously!");
     if (!clearOK)
        return;

     iTrustPageLog.appendBlockBypassEvent(rpt);
     
     rpt.setManual();
     iTrustPage.setMemoryCachedReport(rpt);	  
*/
  },
  ShowIgnore: function () {
	 /*if (rpt.searchAttemptCount == 0){
		 alert ("Please try at least one search before ignoring the warning permanently.");
		 return; 
     }*/

     iTrustPageLog.appendBlockIgnoreBtnEvent(rpt);
     	  
     var boxSearch = document.getElementById("itrustpage-block-search-box");
     boxSearch.collapsed = true;          
     var boxFound = document.getElementById("TrustBlock-found-box");
     boxFound.collapsed = true;          
     
     var boxUnVerify = document.getElementById("TrustBlock-ignore-box");
     boxUnVerify.collapsed = false;          	  
  },
  btnUnVerifyDone: function () {
     var rpt = iTrustPage.getCurrentReport();
/*
     var clearOK = confirm ("Do you wish to proceed to fill the form?\n\nWarning -- it is possible the form you intend to fill will use your information maliciously!");
     if (!clearOK)
        return;
*/
     iTrustPageLog.appendBlockBypassEvent(rpt);

     // Submit report to us if the box is checked.
     var checkbox = document.getElementById("trustblock-submit-suspicious");
     if (checkbox.checked){
	    rpt.SubmitReport ("trustblock-submit-suspicious","");	     
     } 
     
          
     rpt.setManual();
     iTrustPage.setMemoryCachedReport(rpt);	  
  },
  FoundAuto: function (rpt){
           // invalidate domain	        
           //rpt.resetDomain(TrustBlock.currentURI);

           /*
            iTrustPageMain.notificationHide();
            iTrustPageMain.notificationShow ("This Web form was found within the top 10 results of the Google search engine (based on your description). You may now use this Web form.");
            */
            iTrustPageLog.appendBlockAutoFoundEvent(rpt);           
           /*
	        window.clearTimeout(iTrustPage.timerTitle);
            if (rpt.blockTitle && rpt.blockTitle != ""){
               document.title = rpt.blockTitle;
               window.setTimeout(
               function() {
                  var rpt = iTrustPage.getCurrentReport();
	              document.title = rpt.blockTitle;
               }, 500);
           }*/
                      
           rpt.found = true;
           rpt.recheck();
           if (rpt.trusted){
              iTrustPage.setMemoryCachedReport(rpt);
              //TrustBlock.hideBlock();
              
     TrustBlock.RedirectURI = "";
              
     // stop the previewers     
     for (var i=0;i<TrustBlock.maxPreview;i++){     
	   TrustBlock.frameList[i].stop();    
       TrustBlock.frameList[i].setAttribute('src','about:blank');          
     }          
     
     // give users a congrats.     
     iTrustPage.updateStatusbar();                      
     iTrustPage.clearURLBarColor();
     var itrustpage_ver_logo = document.getElementById("itrustpage-ver-logo");
     itrustpage_ver_logo.src="chrome://itrustpage/skin/itp_verified_small.gif";
     
     
     var boxSearch = document.getElementById("itrustpage-block-search-box");
     boxSearch.collapsed = true;          
                                   //alert("E");
                                   //alert("F");              
     var boxFound = document.getElementById("TrustBlock-found-box");
     boxFound.collapsed = true;          
                                   //alert("G");
     var boxVerify = document.getElementById("TrustBlock-verify-box-auto");
     boxVerify.collapsed = false;          

              return;
           }
  },
  btnFound: function (browserid,id) {
     getBrowser().setAttribute('wait-cursor',true);	  
	 
     var frame = document.getElementById(browserid);
     var uri = this.linkList[id];
     TrustBlock.RedirectURI = uri;
     //getBrowser().loadURI(uri);
 
     var urlbar = document.getElementById("urlbar");
 	 urlbar.value = uri;
     
     iTrustPageCache.appendFoundURI(uri,false);
      
          
     var rpt = iTrustPage.getCurrentReport();
     iTrustPageLog.appendBlockManualFoundEvent(rpt,browserid,TrustBlock.RedirectURI);
     
     // change the displayed picture
     var canvas_ver = document.getElementById("preview-original-page-ver");     
     TrustBlock.UpdateView(frame,canvas_ver);	
     //TrustBlock.DrawCheck(canvas_ver);  
     
     // change the displayed URI
     var canvas_uri = document.getElementById("url-original-page-ver");         
     canvas_uri.value = uri;         
     if (canvas_uri.value.length > 30){canvas_uri.value = canvas_uri.value.substr(0,30)+"...";}

     // stop the previewers     
     for (var i=0;i<TrustBlock.maxPreview;i++){     
	   TrustBlock.frameList[i].stop();    
       TrustBlock.frameList[i].setAttribute('src','about:blank');          
     }          
     
     // disable back button
     var cmd_back = document.getElementById("Browser:Back");
     cmd_back.setAttribute("disabled",true);     

     
     // give users a congrats.     
     var boxFound = document.getElementById("TrustBlock-found-box");
     boxFound.collapsed = true;          
     var boxVerify = document.getElementById("TrustBlock-verify-box");
     boxVerify.collapsed = false;          
          
     iTrustPage.updateStatusbar();                      
     iTrustPage.clearURLBarColor();
     var itrustpage_ver_logo = document.getElementById("itrustpage-ver-logo");
     itrustpage_ver_logo.src="chrome://itrustpage/skin/itp_verified_small.gif";
     
     getBrowser().removeAttribute('wait-cursor');
     
  },
  // This is called from the verify box when the user pushes Done
  btnVerifyDone: function (e) {
     getBrowser().setAttribute('wait-cursor',true);	  
  //   TrustBlock.hideBlockDelay();               

     var rpt = iTrustPage.getCurrentReport();
     rpt.blockTitle = "";
     //getBrowser().loadURI(TrustBlock.RedirectURI);
     
     //TrustBlock.hideBlock(); 
     
     if (TrustBlock.RedirectURI != "")
        getBrowser().loadURI(TrustBlock.RedirectURI);
     else
        TrustBlock.hideBlock(); 
     

     // Submit report to us if the box is checked.
     if (TrustBlock.RedirectURI != ""){
        var checkbox = document.getElementById("trustblock-submit-found-manual");
        if (checkbox.checked){
	       rpt.SubmitReport ("trustblock-submit-found-manual",TrustBlock.RedirectURI);	     
        } 
     }else{
        var checkbox = document.getElementById("trustblock-submit-found-auto");
        if (checkbox.checked){
	       rpt.SubmitReport ("trustblock-submit-found-auto",TrustBlock.RedirectURI);	     
        } 	     	     
     }   
             
/*     
     iTrustPageMain.notificationHide();
          
     window.setTimeout(
     function (){
     iTrustPageMain.notificationShow ("You have been redirected away from the suspicious Web form. You may use this Web form instead.");
     },500);
     */
     getBrowser().removeAttribute('wait-cursor');	  
  },
  btnFind: function (e) {     
     TrustBlock.doSearch();
  },
  btnFind2: function (e) {     
     var text  = document.getElementById("TrustBlock-Tags");
     var text_results = document.getElementById("TrustBlock-Tags2");
     
     text.value = text_results.value;
     
     TrustBlock.doSearch();
  },
  onTextChange: function (e){
     var btnCont = document.getElementById("TrustBlock-contbutton");
     var btnCont2 = document.getElementById("TrustBlock-contbutton2");
     var btnOk = document.getElementById("TrustBlock-okbutton");
     var text  = document.getElementById("TrustBlock-Tags");
     var rpt = iTrustPage.getCurrentReport();
	       
     if (rpt.userKeysPressed>=iTrustPageMain.blockKeyThreshold
         && rpt.blockCurrentText != text.value.replace(/ /gi,"")){
//         rpt.searchIsNew = true;          
//       btnOk.disabled=false;
//       btnCont.disabled=false;
//       btnCont2.disabled=false;
     }else{
//       rpt.searchIsNew = false; 
//       btnOk.disabled=true;	     
     }
	  
  },
  loadPreviews: function (){	     
     TrustBlock.loadedPreviewCount = 0;
     TrustBlock.startedPreviewCount = 0;
     
     window.clearTimeout(TrustBlock.loadNextPreviewTimer);
     TrustBlock.loadNextPreviewTimer = window.setTimeout( function (){TrustBlock.loadNextPreview();},10);
     // Display the top result
	  
  },
  loadNextPreview: function (){	  	  
	  if (TrustBlock.startedPreviewCount > TrustBlock.maxPreview)
	     return;
	     
//	  alert (TrustBlock.startedPreviewCount+":"+TrustBlock.linkList[TrustBlock.startedPreviewCount]);
	  TrustBlock.frameList[TrustBlock.startedPreviewCount].setAttribute('src',TrustBlock.linkList[TrustBlock.startedPreviewCount]);  
	  TrustBlock.removeList[TrustBlock.startedPreviewCount] = false;
	  
	  TrustBlock.startedPreviewCount += 1;
	  
	  if (TrustBlock.startedPreviewCount < TrustBlock.maxPreview){
          window.clearTimeout(TrustBlock.loadNextPreviewTimer);
		  TrustBlock.loadNextPreviewTimer = window.setTimeout( function (){TrustBlock.loadNextPreview();},500);
      }
  },
  onKeyDown: function(e) {
     var rpt = iTrustPage.getCurrentReport();
     //var btnOk = document.getElementById("TrustBlock-okbutton");
    
     var text  = document.getElementById("TrustBlock-Tags");
     //alert (e.keyCode);
     if (text.value == "Enter Search Keywords Here")
        text.value = "";
     
     if (e.keyCode == 13 /*&& !btnOk.disabled*/){       
        var searchBox = document.getElementById("itrustpage-block-search-box");  
        var boxFound = document.getElementById("TrustBlock-found-box");
        var boxVerify = document.getElementById("TrustBlock-verify-box");
        var boxVerifyAuto = document.getElementById("TrustBlock-verify-box-auto");
        var boxIgnore = document.getElementById("TrustBlock-ignore-box");
        
        if (!searchBox.collapsed || !boxFound.collapsed){	     
           if (searchBox.collapsed == true){
              var text_results = document.getElementById("TrustBlock-Tags2");
     
              text.value = text_results.value;
           }
           TrustBlock.doSearch();
        }else if (!boxVerify.collapsed || !boxVerifyAuto.collapsed){
	        TrustBlock.btnVerifyDone();
	    }else if (!boxIgnore.collapsed){
		    TrustBlock.btnUnVerifyDone();
	    }                	        
     }else
        ++rpt.userKeysPressed;  

     
  },  
  testSearchResult: function (rpt,linkURI, currentURI, currentDomain) {
	  
     var uriRegexp = 
        /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;
	  
     var RegFirstDomainURI = (currentURI).match(uriRegexp);
	 var RegDomain = (linkURI).match(uriRegexp);

     if (  (iTrustPageMain.blockAllowSubdomains && iTrustPageCommon.utilsIsSameDomain(RegDomain[4],currentDomain))
           || (!iTrustPageMain.blockAllowSubdomains && RegDomain[4] == currentDomain)              
        ){
        
          var pathA = RegDomain[5];
          var pathB = RegFirstDomainURI[5];       
          
          
          //alert (iTrustPageCommon.utilsExtractPath(pathA) + "," + iTrustPageCommon.utilsExtractPath(pathB))
          
          if (!iTrustPageMain.blockPathMustMatch
              || iTrustPageCommon.utilsExtractPath(pathA) == iTrustPageCommon.utilsExtractPath(pathB))

              return true;

     }	  
        
     return false;
  },
  doSearch: function (e) {     
     getBrowser().setAttribute('wait-cursor',true);
  
     // grab handles
     var text  = document.getElementById("TrustBlock-Tags");
     var text_results = document.getElementById("TrustBlock-Tags2");
     
     var btnOk = document.getElementById("TrustBlock-okbutton");
     var btnFound = document.getElementById("TrustBlock-foundbutton");             
     var boxFound = document.getElementById("TrustBlock-found-box");
     var btnCont = document.getElementById("TrustBlock-contbutton");
     var btnCont2 = document.getElementById("TrustBlock-contbutton2");

     var loadingIcon = document.getElementById("TrustBlock-loading-icon");
     var searchBox = document.getElementById("itrustpage-block-search-box");  
     var boxFound = document.getElementById("TrustBlock-found-box");
     
          
     // setup reg expressions
     //var GoogleRegexp = /<a href="([^"]+)" class=l/g; /* Google changed their link style on jan 31st */
     var GoogleRegexp = /<a class=l href="([^"]+)"/g;
     //var linkRegexp = /<a href="([^"]+)" class=l/;
     var linkRegexp = /<a class=l href="([^"]+)"/;

     var rpt = iTrustPage.getCurrentReport();
     iTrustPageLog.appendBlockSeachEvent(rpt,text.value);

	 rpt.userKeysPressed=0;

     if (text.value == ""){
        alert("You entered no text into the provided input box. Please enter a search string.");
        return;
     }

      
//     if (rpt.blockCurrentText != text.value.replace(/\s/gi,"")){
        ++rpt.searchAttemptCount;

        iTrustPage.setMemoryCachedReport(rpt);
     loadingIcon.collapsed = false;
/*     }else{
        iTrustPageMain.notificationHide();
        alert ("You must change the terms used in your search description.");	     

	     
        loadingIcon.collapsed = true;
        //frame.collapsed = false;     
     }*/
     iTrustPageCache.appendSearchURI(rpt.currentURI);
     
     text_results.value = text.value;
     
     // Parse textbox
     var tags = encodeURI ( text.value);

     var firstDomainStripped = this.firstDomain;
     var firstDomainSplit = firstDomainStripped.split('.');
     var domainNoMatch = "";

     for (var i=0;i<firstDomainSplit.length-1;++i){
        domainNoMatch =           
           firstDomainSplit[i]+'.'+
           firstDomainSplit[i+1];

        if (tags.search(domainNoMatch) >= 0){
	        alert ("Search query cannot contain the domain");
    	    return;  	     
        }        	     
     }      
     
     if (domainNoMatch != "" && tags.search(domainNoMatch) >= 0){
	    alert ("Search query cannot contain the domain ( "+firstDomainStripped+" )");
	    return;  	     
     }
  
     // Query Google
     var querystring = "http://www.google.com/search?hl=en&q="
                       +tags+"&btnG=Google+Search&meta=";   

     this.mGoogleRequest = new XMLHttpRequest();
 	  this.mGoogleRequest.open( "GET", querystring,false,"","" );
	  this.mGoogleRequest.setRequestHeader( "User-Agent", 
	     "Mozilla/4.0 (compatible; Windows XP 5.1)" );
     this.mGoogleRequest.send( null );

     var GoogleResponse = this.mGoogleRequest.responseText;
         
     // Parse Top Results
     this.linkList = new Array();
     this.linkIndex = 0;
     var RegLink = GoogleResponse.match(GoogleRegexp);        
          
     if (!RegLink || RegLink.length == 0){
        GoogleRegexp = /<a href="([^"]+)" class=l/g; /* Google changed their link style on jan 31st */
        linkRegexp = /<a href="([^"]+)" class=l/;

        RegLink = GoogleResponse.match(GoogleRegexp);        
     }
     
     if (RegLink){
     for (i=0;i<RegLink.length;i++){ 
        var link = (RegLink[i]).match(linkRegexp);    
        
        // log this URL.
        iTrustPageLog.appendGoogleResult(link[1], i);
        
        this.linkList.push(link[1]);

        /* Check if the start of the navigation path matches the search results */
        if (this.testSearchResult (rpt,link[1],TrustBlock.firstDomainURI,TrustBlock.firstDomain)){
            iTrustPageCache.appendFoundURI(TrustBlock.firstDomainURI,true);
            iTrustPageCache.appendFoundURI(TrustBlock.currentURI,true);
 	       TrustBlock.FoundAuto(rpt);
              
 	       return;          	        
	        //break;
        }        
        
        // we also want to check if the current URI matches the search results 
        if (this.testSearchResult (rpt,link[1],TrustBlock.currentURI,TrustBlock.currentDomain)){
	        
           rpt.initState();
           iTrustPageCache.appendFoundURI(TrustBlock.currentURI,true);
	       TrustBlock.FoundAuto(rpt);
           
 	       return;          	        
//           break;	        
        }        
        
    } 
    
    // set report state
    rpt.tagString = text.value;
    rpt.linkList = this.linkList;     
    rpt.linkURI = this.linkList[this.linkIndex];
    rpt.linkIndex = this.linkIndex;
             
    TrustBlock.loadPreviews();

    window.clearTimeout(TrustBlock.previewTimer);
     TrustBlock.previewTimer = window.setTimeout(
         function (){TrustBlock.UpdateTimer()},0);
     
     
     if (iTrustPageMain.enableBlockExtraInformation)
        TrustBlock.doQueryCategory();


    }else{
//        ++rpt.searchAttemptCount;
	   alert ("iTrustPage did not find any pages related to your description. Please try again.");
//           this.refreshInformation();
	    
       rpt.tagString = text.value;
       boxFound.collapsed=true;              
     }
     for (var i=0;i<TrustBlock.maxPreview;i++){     
	   TrustBlock.frameList[i].stop();    
       TrustBlock.frameList[i].setAttribute('src','about:blank');          
     }     
         
     var remainingSearchCount = rpt.totalSearches-rpt.searchAttemptCount;     
     rpt.userKeysPressed=0;
     
     //var text  = document.getElementById("TrustBlock-Tags");	       
     rpt.blockCurrentText = text.value.replace(/\s/gi,"");
     
     if (this.linkList.length > 1){
        searchBox.collapsed = true;
        boxFound.collapsed=false;        
     }
     
     this.refreshInformation();
          
     getBrowser().removeAttribute('wait-cursor');
         
     if (iTrustPageMain.blockAllowBypass && remainingSearchCount <= 0){
	    this.btnCont (null);	     
     }
          
  }, 

  btnRefine: function (){
     var searchBox = document.getElementById("itrustpage-block-search-box");  
     searchBox.collapsed = false;
     
     var boxFound = document.getElementById("TrustBlock-found-box");
     boxFound.collapsed = true;     
     
     var text  = document.getElementById("TrustBlock-Tags");
     text.select();     
  },
  doQueryCategory: function (){
     if (TrustBlock.CategoryQuery)
        TrustBlock.CategoryQuery.abort();

     var previewDescription = document.getElementById("itrustpage-trustblock-preview_description");  
     previewDescription.textContent = "Unknown";
     previewDescription.setAttribute("tooltiptext","Unknown");

     var tags;
     // get domain
     var myregexp = /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;
     var RegDomain = String(this.linkList[this.linkIndex]).match(myregexp);
     
     // Parse url
     if (RegDomain[4])
        TrustBlock.CategoryTags = encodeURI ( RegDomain[4] );
     else
        TrustBlock.CategoryTags = encodeURI ( this.linkList[this.linkIndex] );

     // Query Yahoo Directory
//     var querystring = "http://search.yahoo.com/search/dir?p="
//                       +tags+"&ei=UTF-8&fr=yfp-t-500&n=10&fl=0&x=drt";   

     // Query Google Directory
     var querystring = "http://www.google.com/search?q="
                       +TrustBlock.CategoryTags+"&BtnG=Search+Directory&hl=en&cat=gwd%2FTop";   

//                       alert(querystring);
     TrustBlock.CategoryQuery = new XMLHttpRequest();
   
 	  TrustBlock.CategoryQuery.onload = function (ev) {	 	   
   	   TrustBlock.doneQueryCategory();
     }
     TrustBlock.CategoryQuery.open( "GET", querystring,true,"","" );
     TrustBlock.CategoryQuery.send( null );  
  },  
  doneQueryCategory: function (){
     var previewDescription = document.getElementById("itrustpage-trustblock-preview_description");  
  
    var response = TrustBlock.CategoryQuery.responseText;
//    alert(response);

     // setup reg expressions
     var GoogleRegexp = /<a class=l[^\0]*?>([^\0]*?)<\/a>[^\0]*?<span class=f>.*?<a[^\0]*?>([^\0]*?)<\/a><br>([^\0]*?)<span class=a>([^\0]*?) /gi;
     var linkRegexp = /<a class=l[^\0]*?>([^\0]*?)<\/a>[^\0]*?<span class=f>.*?<a[^\0]*?>([^\0]*?)<\/a><br>([^\0]*?)<span class=a>([^\0]*?) /i;

     var RegLink = response.match(GoogleRegexp);        
          
     if (RegLink){
        for (i=0;i<RegLink.length;i++){ 
           var link = (RegLink[i]).match(linkRegexp);    
           if (link){
              var desc = link[3].replace(/<br>/g,"");
              var category = link[2].replace(/<br>/g,"");
              var title = link[1].replace(/<br>/g,"");

              category = category.replace(/&amp;/g,"&");
              category = category.replace(/&nbsp;/g," ");
              category = category.replace(/&gt;/g,">");
              category = category.replace(/&lt;/g,"<");
              title = title.replace(/&amp;/g,"&");
              title = title.replace(/&nbsp;/g," ");
              title = title.replace(/&gt;/g,">");
              title = title.replace(/&lt;/g,"<");
              desc = desc.replace(/&amp;/g,"&");
              desc = desc.replace(/&nbsp;/g," ");
              desc = desc.replace(/&gt;/g,">");
              desc = desc.replace(/&lt;/g,"<");

              category = category.replace(/[^\0]*?\.\.\. >/,"");
                                          
              if (desc.length > 100)
                 desc = desc.substring(0,100)+"...";
              
              if (TrustBlock.CategoryTags+"/" == link[4]){
                 previewDescription.textContent = ""+category;
                 previewDescription.setAttribute("tooltiptext",title+": "+desc);
                 break;
              }                 
           }
        }
     }
 },


  doQueryCategoryForBlock: function (){
     if (TrustBlock.CategoryBlockQuery)
        TrustBlock.CategoryBlockQuery.abort();

     var rpt = iTrustPage.getCurrentReport(); 
     var previewDescription = document.getElementById("itrustpage-trustblock-block_description");  
     previewDescription.textContent = "Unknown";
     previewDescription.setAttribute("tooltiptext","Unkown");

     // get domain
     var myregexp = /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;
     var RegDomain = String(rpt.firstDomainURI).match(myregexp);
     
     // Parse url
     if (RegDomain[4])
        TrustBlock.CategoryBlockTags = encodeURI ( RegDomain[4] );
     else
        TrustBlock.CategoryBlockTags = encodeURI ( rpt.firstDomainURI );

     // Query Yahoo Directory
//     var querystring = "http://search.yahoo.com/search/dir?p="
//                       +tags+"&ei=UTF-8&fr=yfp-t-500&n=10&fl=0&x=drt";   

     // Query Google Directory
     var querystring = "http://www.google.com/search?q="
                       +TrustBlock.CategoryBlockTags+"&BtnG=Search+Directory&hl=en&cat=gwd%2FTop";   

//                       alert(querystring);
     TrustBlock.CategoryBlockQuery = new XMLHttpRequest();
   
 	  TrustBlock.CategoryBlockQuery.onload = function (ev) {	 	   
   	   TrustBlock.doneQueryCategoryForBlock();
     }
     TrustBlock.CategoryBlockQuery.open( "GET", querystring,true,"","" );
     TrustBlock.CategoryBlockQuery.send( null );  
  },  
  doneQueryCategoryForBlock: function (){
     var previewDescription = document.getElementById("itrustpage-trustblock-block_description");  
  
    var response = TrustBlock.CategoryBlockQuery.responseText;
//    alert(response);

     // setup reg expressions
     var GoogleRegexp = /<a class=l[^\0]*?>([^\0]*?)<\/a>[^\0]*?<span class=f>.*?<a[^\0]*?>([^\0]*?)<\/a><br>([^\0]*?)<span class=a>([^\0]*?) /gi;
     var linkRegexp = /<a class=l[^\0]*?>([^\0]*?)<\/a>[^\0]*?<span class=f>.*?<a[^\0]*?>([^\0]*?)<\/a><br>([^\0]*?)<span class=a>([^\0]*?) /i;

     var RegLink = response.match(GoogleRegexp);        
          
     if (RegLink){
        for (i=0;i<RegLink.length;i++){ 
           var link = (RegLink[i]).match(linkRegexp);    
           if (link){
              var desc = link[3].replace(/<br>/g,"");
              var category = link[2].replace(/<br>/g,"");
              var title = link[1].replace(/<br>/g,"");

              category = category.replace(/&nbsp;/g," ");
              category = category.replace(/&amp;/g,"&");
              category = category.replace(/&gt;/g,">");
              category = category.replace(/&lt;/g,"<");
              title = title.replace(/&amp;/g,"&");
              title = title.replace(/&nbsp;/g," ");
              title = title.replace(/&gt;/g,">");
              title = title.replace(/&lt;/g,"<");
              desc = desc.replace(/&amp;/g,"&");
              desc = desc.replace(/&nbsp;/g," ");
              desc = desc.replace(/&gt;/g,">");
              desc = desc.replace(/&lt;/g,"<");
              
              category = category.replace(/[^\0]*?\.\.\. >/,"");
              
              if (desc.length > 100)
                 desc = desc.substring(0,100)+"...";
                 
              if (TrustBlock.CategoryBlockTags+"/" == link[4]){
                 previewDescription.textContent = ""+category;
                 previewDescription.setAttribute("tooltiptext",title+": "+desc);
                 break;
              }                 
           }
        }
     }
 },  
};

window.addEventListener("load", function(e) { TrustBlock.onLoad(e); }, false); 
