/* $Id: iTrustPage.js 10 2006-11-29 01:44:45Z troyronda $ */

/* iTrustPage
 * Copyright (c) 2006 Troy Ronda and the University of Toronto.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

 
var iTrustPage = {
  initialized: false,
  trustReportCache: new Array(),
  trustReportCacheMax: 25,
  trustReportCacheEntries: new Array(),
  trustReportTab: new Array(),
  urlbarFocus: false,
  shownIcon: false,
  doneKeyboardChecks: false,

  onLoad: function(ev) {
	  
//	  	  alert ("onLoad");

    // initialization code
    if (this.initialized)
       return;    
    this.initialized = true;      

    iTrustPageGoogleList.load();
       
    //var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
     var b = iTrustPage.getCurrentBrowser();
    
    iTrustPage.urlbar_itrustpage = document.getElementById("urlbar-itrustpage");        
    iTrustPage.urlbar = document.getElementById("urlbar");
    iTrustPage.urlbar_container = document.getElementById("urlbar-container");
   
    getBrowser().addProgressListener(iTrustPage_progressListener);

    
   // locationChangeHandler(ev);
    getBrowser().addEventListener("pageshow",iTrustPage.onPageShow,true);
    getBrowser().addEventListener("pagehide",iTrustPage.onPageHide,true);
    getBrowser().addEventListener("DOMContentLoaded",iTrustPage.onDOMContentLoaded,true);
    
    getBrowser().mPanelContainer.addEventListener("select",iTrustPage.onTabSelected,true);
    
    
    //alert ("?");
    iTrustPage.OriginalURLBarBgcolor = "";
    iTrustPage.OriginalURLBarContainerBgcolor = "";
    iTrustPage.OriginalURLBarFontWeight = "";
    iTrustPage.OriginalURL = "";
    iTrustPage.getMemoryCachedReportLastUri="";
    iTrustPage.uri_isGoogleFirstPage = false;
    iTrustPage.uri_typed = false;
    iTrustPage.uri_typed_keys=0;
    
//    var cmd_back = document.getElementById("Browser:Back");
//    cmd_back.setAttribute("oncommand","iTrustPage.onBrowserBackButton();");
  
    // TODO: load cache

     // add focus/blur handlers to urlbar    
    //var urlbar = document.getElementById("urlbar-container");
    iTrustPage.urlbar_container.addEventListener("focus",iTrustPage.onUrlBarFocus,true);
    iTrustPage.urlbar_container.addEventListener("blur",iTrustPage.onUrlBarBlur,true);

    //window.addEventListener("focus",iTrustPage.onWindowFocus,true);  
        //urlbar.addEventListener("focus",iTrustPage.onInputFocus,true);
        //urlbar.addEventListener("blur",iTrustPage.onInputBlur,true);      	      
    
    
//	  	  alert ("done onLoad");
  },
  onSecurityChange : function(a,b,c){
     var uri = String(window.content.document.location);
//	 alert("onSecurityChange: "+uri);	  	  
  },
  onLocationChange : function(aProgress,aRequest,aLocation) {            
     var uri = String(window.content.document.location);
//	 alert("onLocationChange: "+uri+", "+aRequest.name);
	 //alert("onLocationChange: "+uri +", "+iTrustPage.OriginalURL);	  
//	  alert (aRequest.name);
     iTrustPage.shownIcon = false;
     iTrustPage.doneKeyboardChecks = false;
      //    alert("???");
      if (/*window.content.document.body && window.content.document.body != "null" &&*/  iTrustPage.OriginalURL != uri){
       //   alert("??");
//		  iTrustPage.doWindowContentDocumentActions();
          
         // alert("?");
         var uriRegexp = 
            /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;

        var result_uri = uri.match(uriRegexp);     
        /* extract authority */
        var uri_authority = result_uri[4];
          
        var orig_result_uri = iTrustPage.OriginalURL.match(uriRegexp);     
        /* extract authority */
        var orig_uri_authority = orig_result_uri[4];
        
  //      alert (uri_authority.toLowerCase()+", "+orig_uri_authority.toLowerCase());
        if (uri_authority.toLowerCase() != orig_uri_authority.toLowerCase()){
          TrustBlock.hideBlockSmallDelay();                
        }
	  }
	  /*
     var b = iTrustPage.getCurrentBrowser();
    var uri = String(b.contentDocument.location);

alert ("test: "+uri);
*/
	  iTrustPage.updateStatusbar();
  },
  onStatusChange: function (a,b,c,d){
     var uri = String(window.content.document.location);
//	 alert("onStatusChange: "+uri);	  
  },	  
  onStateChange: function (aProgress,aRequest,aFlag,aStatus){
     var uri = String(window.content.document.location);
     
//	 var rpt = iTrustPage.getCurrentReport();     
//     iTrustPageLog.appendEventNavigation(rpt);	     
     
      if (uri != aRequest.name){ /* record that there could be a redirect */
	      iTrustPage.redirectURI = String(aRequest.name);
         //alert (aRequest.name);	         
      }
//	  alert("onStateChange: "+uri+", "+aRequest.name);
//	  alert (aRequest);
	  //alert (aRequest.name);
  },  
  onProgressChange: function (a,b,c,d,e,f){
  //   alert("onProgressChange: "+uri +"       :    "+iTrustPage.OriginalURL);	  	  
/*     var uri = String(window.content.document.location);
	 
     alert("onProgressChange: "+uri +"       :    "+iTrustPage.OriginalURL);	  	  

      if (window.content.document.body && window.content.document.body != "null" &&  iTrustPage.OriginalURL != uri){
		  iTrustPage.doWindowContentDocumentActions();
	  }
*/	  
  },
  doWindowContentDocumentActions: function (){
     var uri = String(window.content.document.location);
     var referrer = String (window.content.document.referrer);
     
//		  alert ("in if");
     //alert (uri);
     //alert (referrer);
          
     /* examine URL and Referrer for google */
     var uriRegexp = 
        /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;

     var result_uri = uri.match(uriRegexp);
     
     /* extract authority */
     var uri_authority = result_uri[4];
     
     /* extract paths */
     var uri_path = result_uri[5];
     
     /* extract query string */
     var uri_query = result_uri[6];
     
     /* strip www from authority */
     uri_authority = iTrustPageCommon.utilsStipDomain(uri_authority);
          
     /* check for Google authority */
     var uri_isGoogleFirstPageOriginal = iTrustPage.uri_isGoogleFirstPage;
     
     iTrustPage.uri_isGoogleFirstPage = false;
     iTrustPage.uri_isGoogleSearch = false;
     //alert (uri_authority+"   "+uri_path + "    "+uri_query);
     if (iTrustPageGoogleList.GoogleList[uri_authority] == 1){
	     if (uri_path.toLowerCase() == "/search"){
             iTrustPage.uri_isGoogleSearch = true;
		     if (uri_query.indexOf("&start") == -1 || uri_query.indexOf("&start=0&") != -1){
//	            alert ("uri is Google Search (first page)");    
                iTrustPage.uri_isGoogleFirstPage = true;                
             }
     
             var queryRegexp = /&q=([^&]*)/;        
             var uri_query_result = uri_query.match(queryRegexp);
             
             iTrustPageLog.appendGoogleSeachEvent(uri_query_result[1]);
             
             //alert ("Google keywords are: "+uri_query_result[1]);
         }
     }

     iTrustPage.referrer_isGoogleFirstPage=false;
     iTrustPage.uri_typed = false;
    iTrustPage.uri_typed_keys=0;

     
     /* ensure two things: 1) we are not still on Google search, 2) the last page was actually Google Search */
     if ( !iTrustPage.uri_isGoogleSearch && uri_isGoogleFirstPageOriginal && referrer != ""){
     var result_referrer = referrer.match(uriRegexp);
     
     /* extract authority */
     var referrer_authority = result_referrer[4];
     
     /* extract paths */
     var referrer_path = result_referrer[5];
     
     /* extract query string */
     var referrer_query = result_referrer[6];
     
     /* strip www from authority */
     referrer_authority = iTrustPageCommon.utilsStipDomain(referrer_authority);
          
     /* check for Google authority */
     //alert (referrer_authority+"   "+referrer_path + "    "+referrer_query);
     if (iTrustPageGoogleList.GoogleList[referrer_authority] == 1){
	     if (referrer_path.toLowerCase() == "/search"){
		     if (referrer_query.indexOf("&start") == -1 || referrer_query.indexOf("&start=0&") != -1){
//	            alert ("referrer is Google Search (first page)");    
                iTrustPageLog.appendGoogleNavigationFirstPage(uri);
                iTrustPage.referrer_isGoogleFirstPage=true;
                
                // log this event
                
             }
         }
     }
     }
          
     //(.indexOf() == -1)
     
     
     //var uri = String(window.content.document.location);

            
     /* examine  for google results */         
     /* log if found */  
          
         iTrustPage.InputHasFocus=false;    

            	   
         
   	     iTrustPage.OriginalURL = String(uri);
//   	     alert ("iTrustPage.OriginalURL: "+iTrustPage.OriginalURL);
   	     
     	 iTrustPage.addInputHandlers3(window.content.document.body); 
         iTrustPage.addDocumentContentEventListeners();
         
	     // this is a hack... basically, we store the lastURI in the FireFox preferences
	     // so that we can maintain history when the user clicks open link in a new 
	     // tab or window. This means we need to grab this uri before the newly loaded
   	     // document overwrites it.
         //var rpt = iTrustPage.getCurrentReport();         
         var rpt = iTrustPage.checkCurrentUri (/*trackingOnly=*/true );
         
         /* HACK!! Look for .focus() in all script objects */
         /* This case happens when there is javascript embedded directly behind an input box... 
            the hack does seem to cover common cases like paypal.com and google.com/ig */
         //iTrustPage.detectFocusInScripts(window.content.document.body);
                  
	  
  },
  onDOMContentLoaded: function (ev){
     var uri = String(window.content.document.location);
//	 alert("onDOMContentLoaded: "+uri);
//     alert("onDOMContentLoaded: "+uri +"       :    "+iTrustPage.OriginalURL);	  	  
	 	 	  	  
	  if (window.content.document.body && window.content.document.body != "null" &&  iTrustPage.OriginalURL != uri){
          iTrustPage.doneKeyboardChecks = false;
		  iTrustPage.doWindowContentDocumentActions();
	  }
	 //alert("done onDOMContentLoaded: "+uri);

  },
  /* getElementsByTagName WILL NOT GRAB IFRAME CHILDREN!!!! BEWARE!!! */
 /* detectFocusInScripts: function (node){
	  	  
	  // loop through child list 
      if (node.contentDocument){
	      //alert (node.tagName);
	      iTrustPage.detectFocusInScripts(node.contentDocument);
      }
      
	     for (var i=0;i<node.childNodes.length;i++){
	        iTrustPage.detectFocusInScripts(  node.childNodes[i] ); 		  
         }
      
      
      if (node.tagName && node.tagName.toLowerCase() == "script"){
	      //alert (node.textContent);
	      if (node.textContent.search(".focus") >= 0){
             iTrustPage.InputHasFocus=true;    		      
	      }
      }
  },*/
  /* getElementsByTagName WILL NOT GRAB IFRAME CHILDREN!!!! BEWARE!!! THIS IS SLOW */
  addInputHandlers2: function (node){
	  	  
	  /* loop through child list */
      if (node.contentDocument){
	      //alert (node.tagName);
	      iTrustPage.addInputHandlers2(node.contentDocument);
      }
      
	     for (var i=0;i<node.childNodes.length;i++){
	        iTrustPage.addInputHandlers2(  node.childNodes[i] ); 		  
         }
      
      
      if (node.tagName && node.tagName.toLowerCase() == "textarea"){
        node.addEventListener("focus",iTrustPage.onInputFocus,true);
        node.addEventListener("blur",iTrustPage.onInputBlur,true);      	      
      }
      if (node.tagName && node.tagName.toLowerCase() == "input"){
        node.addEventListener("focus",iTrustPage.onInputFocus,true);
        node.addEventListener("blur",iTrustPage.onInputBlur,true);      	      
      }
      if (node.tagName && node.tagName.toLowerCase() == "form"){
	     // replace onsubmit function
         node.addEventListener("submit",iTrustPage.handleOnSubmit,true);
         
      }
      if (node.tagName && node.tagName.toLowerCase() == "script"){
	      if (node.textContent.search(".focus") >= 0){
             iTrustPage.InputHasFocus=true;    		      
	      }
      }      
  },
  /* getElementsByTagName WILL NOT GRAB IFRAME CHILDREN!!!! BEWARE!!! */
  addInputHandlers3: function (node){
	  
	  /* recursive call for iframes */
      var allFrames = node.getElementsByTagName("iframe");     	  
      for (var i=0;i<allFrames.length;i++){
         iTrustPage.addInputHandlers3(  allFrames[i].contentDocument ); 		  
      }
	  /* recursive call for frames */
      var allFrames = node.getElementsByTagName("frame");     	  
      for (var i=0;i<allFrames.length;i++){
         iTrustPage.addInputHandlers3(  allFrames[i].contentDocument ); 		  
      }
	  	        
      var allItems = node.getElementsByTagName("input");     	  
	  for (var i=0;i<allItems.length;i++){
		node = allItems[i];
        node.addEventListener("focus",iTrustPage.onInputFocus,true);
        node.addEventListener("blur",iTrustPage.onInputBlur,true);      	      
      }
      
      var allItems = node.getElementsByTagName("textarea");     	  
	  for (var i=0;i<allItems.length;i++){
//      alert ("textarea adding a");
//		  alert (allItems[i].name);
		node = allItems[i];
        node.addEventListener("focus",iTrustPage.onInputFocus,true);
        node.addEventListener("blur",iTrustPage.onInputBlur,true);      	      
      }
                  
      
      var allItems = node.getElementsByTagName("form");     	  
	  for (var i=0;i<allItems.length;i++){
		node = allItems[i];
	     // replace onsubmit function
         node.addEventListener("submit",iTrustPage.handleOnSubmit,true);         
      }
      
      /* this code can be wrong for sites like www.phdcomics.com/comics */
      var allItems = node.getElementsByTagName("script");     	  
	  for (var i=0;i<allItems.length;i++){
		node = allItems[i];
	      if (node.textContent.search(".focus") >= 0){
             iTrustPage.InputHasFocus=true;    
                  iTrustPage.shownIcon = true;
		      
	      }
      }      
  },  
  handleOnSubmit: function (ev){
	 /* add event to log */
	 var rpt = iTrustPage.getCurrentReport();     
	 iTrustPageLog.appendEventSubmitForm(rpt);
     //alert (ev);	  
  },
  addInputHandlers: function (){
	 // Add handlers to all INPUTs
     var allInputs = getBrowser().contentDocument.getElementsByTagName("input");     
     var num = allInputs.length;
     //alert("There are " + num + " <input> elements in this document");
     
     for (var i=0;i<allInputs.length;++i){
        allInputs[i].addEventListener("focus",iTrustPage.onInputFocus,true);
        allInputs[i].addEventListener("blur",iTrustPage.onInputBlur,true);                
     }  	  
  },
  getCurrentBrowser: function (){
    var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
        
     return b;
  },
  getCurrentBrowserTarget: function (target){
     for (var i=0;i<getBrowser().mTabContainer.childNodes.length; ++i){
        var b = getBrowser().getBrowserAtIndex(i);
   	     
        if (b.contentDocument == target)
           break;
     }
     
     var b;
     if (i == getBrowser().mTabContainer.childNodes.length)
        b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);     
     else 
        b = getBrowser().getBrowserAtIndex(i);	  
        
        
        
     return b;
  },
  onPageShow: function (e) {    	   	 
	 // alert ("PageShow A");
     var b = iTrustPage.getCurrentBrowserTarget(e.target);
     iTrustPage.doneKeyboardChecks = false;
//	 alert ("PagesShow");

	 // alert ("PageShow B");
     iTrustPage.addInputHandlers3(b.contentDocument);     
     
               
	 // alert ("PageShow C");
     iTrustPage.msgText = "";
     iTrustPage.addContentEventListeners(e);
     
     var rpt;
//     if (iTrustPageMain.checkOnPageLoad)
//        rpt = iTrustPage.checkCurrentUri (false);
//     else {
	  //alert ("PageShow D");
        rpt = iTrustPage.checkCurrentUri (true);
//     }
      
        if (iTrustPage.referrer_isGoogleFirstPage){	        
         //   var rpt = iTrustPage.checkCurrentUri (true);
            
            if (!rpt.trusted){          	      	    
	        rpt.googleFirstPage=true;
            rpt.recheck();
	        
            if (rpt.trusted){
	            iTrustPageLog.appendBlockGoogleFoundEvent(rpt);
	            
	            //TrustBlock.hideBlock();
                iTrustPage.setMemoryCachedReport(rpt);
            }
            }
        }	 
        
	 //var rpt = iTrustPage.getCurrentReport();     
	 // alert ("PageShow E");
     var uri = String(window.content.document.location);
     var referrer = String (window.content.document.referrer);
	 // alert ("PageShow F");
     iTrustPageLog.appendEventNavigation(rpt,uri,referrer);	     
	 // alert ("PageShow G");
	 
     

  },  
  onCheckInformation: function (){  
	 var rpt = iTrustPage.getCurrentReport();     

     iTrustPage.updateNotificationBar(true);
          
  },   
//  onWindowFocus: function (ev) { 
     
//  },
/*  onDocumentBlur: function (ev) {
	  iTrustPage.onInputBlur(ev);
  },*/
  doTrustCheckFromEvent: function (ev){
     if (iTrustPageMain.checkOnInputFocus){
        if (ev.target && ev.target.tagName &&
            (ev.target.tagName.toLowerCase() == "textbox" ||
             ev.target.tagName.toLowerCase() == "input" ||
             ev.target.tagName.toLowerCase() == "select" ||
             ev.target.tagName.toLowerCase() == "textarea" ||
             ev.target.tagName.toLowerCase() == "button"
           )){
         
            var rpt = iTrustPage.checkCurrentUri (false);
            //var rpt = iTrustPage.getCurrentReport();     
     	    rpt.setIsForm();
            
            if (rpt.trusted == false){
               ev.preventDefault();
               ev.stopPropagation();
            }

        }
     }   
        if (iTrustPageMain.checkAllObjects &&
            ev.target && ev.target.tagName &&
            (ev.target.tagName.toLowerCase() == "embed"
            || ev.target.tagName.toLowerCase() == "object")

           ){
           
            //alert(ev.target.tagName.toLowerCase());	
            var rpt = iTrustPage.checkCurrentUri (false);
         	//var rpt = iTrustPage.getCurrentReport();     
     	    rpt.setIsForm();

            
            if (rpt.trusted == false){
               ev.preventDefault();
               ev.stopPropagation();
            }
           
           
           }
  },
 /* onDocumentFocus: function (ev) {
     iTrustPage.doTrustCheckFromEvent(ev);
  },*/
  /*onDocumentMouse: function (ev) {
	 var rpt = iTrustPage.getCurrentReport();     
	  
	// alert(ev);
	 

     iTrustPage.doTrustCheckFromEvent(ev);
  },*/
  onUrlBarFocus: function(ev) {
     iTrustPage.urlbarFocus = true;
     
     if (iTrustPage.shownIcon)
        iTrustPage.onInputFocus(ev);
     
//     alert ("urlbarfocus"+iTrustPage.urlbarFocus);
  },
  onUrlBarBlur: function(ev) {
     iTrustPage.urlbarFocus = false;
     iTrustPage.onInputBlur(ev);
  },
  onInputEvent: function (ev,fromBrowser){
     iTrustPage.onKeyboardEvent(ev,fromBrowser);
/*     if (ev.iTrustPageCaught)
        return;
          
     //if (iTrustPageMain.checkOnKeyboardEvent){

        if (ev.altKey || ev.ctrlKey || ev.metaKey)
           return;
         
        if (ev.charCode == 0 || ev.charCode == 32 || ev.charCode == 8)
           return;
	       
        var rpt = iTrustPage.checkCurrentUri (false);
  	    //var rpt = iTrustPage.getCurrentReport();     

        //var urlbar_itrustpage = document.getElementById("urlbar-itrustpage");        
        if (iTrustPage.urlbar_itrustpage.collapsed){
           iTrustPage.InputHasFocus=true;	  
	       iTrustPage.updateStatusbar();
        }
  	      	    
  	    if (!rpt.isform){
    	    rpt.setIsForm();
           //iTrustPage.setMemoryCachedReport(rpt);
	    }
            
        if (rpt.trusted == false){
           ev.preventDefault();
           ev.stopPropagation();
           
           if (ev.target.value){
	           ev.target.value = "";
           }
        }
     //}
     */
  },
  onKeyboardEvent: function (ev,fromBrowser){
     
        if (ev.altKey || ev.ctrlKey || ev.metaKey)
           return;
         
        if (ev.charCode == 0 || ev.charCode == 32 || ev.charCode == 8)
           return;

        if (fromBrowser)
           iTrustPage.uri_typed_keys++;
           
        if (ev.iTrustPageCaught)
           return;
        ev.iTrustPageCaught = true; // don't delete value
                              
                                 
        if (!iTrustPage.doneKeyboardChecks && iTrustPage.referrer_isGoogleFirstPage){	        
            var rpt = iTrustPage.checkCurrentUri (true);
            
            if (!rpt.trusted){          	      	    
	        rpt.googleFirstPage=true;
            rpt.recheck();
	        
               if (rpt.trusted){
    	            iTrustPageLog.appendBlockGoogleFoundEvent(rpt);
	            
                    iTrustPage.setMemoryCachedReport(rpt);
               }
            }
        }
        // We need to do some caching here... just to slow to 
        // run thru the entire call stack every time
        if (!iTrustPage.doneKeyboardChecks){
           var rpt = iTrustPage.checkCurrentUri (false); 	      	    

           if (!iTrustPage.uri_typed){
	          iTrustPageLog.appendEventFormTypedAll    (rpt);
	          iTrustPage.uri_typed=true;
           }
          	      	    
  	       if (!rpt.isform){
  	          rpt.setIsForm();
              iTrustPage.setMemoryCachedReport(rpt);
           }
                    
           if (rpt.trusted == false){
              ev.preventDefault();
              ev.stopPropagation();
           }
           
           if (rpt.trusted && rpt.isform)
              iTrustPage.doneKeyboardChecks=true;
        
        }        
        if (iTrustPage.urlbar_itrustpage.collapsed){
	        //alert ("updating status bar");
           iTrustPage.InputHasFocus=true;	  
     	   iTrustPage.updateStatusbar();   
        }
        
  },
  getCurrentReport: function() {
//    var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
     var b = iTrustPage.getCurrentBrowser();
    var uri = String(b.contentDocument.location);
    
    return iTrustPage.getUriReport(uri,true); 
  },
  getCurrentReportNoTrack: function() {
//    var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
     var b = iTrustPage.getCurrentBrowser();

    var uri = String(b.contentDocument.location);
    
    return iTrustPage.getUriReport(uri,false); 
  },
  checkCurrentUri: function(trackingOnly) {
//     var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
     var b = iTrustPage.getCurrentBrowser();

     var uri = String(b.contentDocument.location);
     
     //alert ("checkCurrentUri");
     var rpt = iTrustPage.doTrustCheck (uri,trackingOnly); 
     //alert ("done checkCurrentUri");
     
     return rpt;
  },  
  getMemoryCachedReport: function(uri){
	  
	 if (iTrustPage.getMemoryCachedReportLastUri == uri){ 
        return iTrustPage.trustReportCache[iTrustPage.getMemoryCachedReportMangledUri];  	  		 		 		 
     }
	  
     var myregexp = /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;
     var RegDomain = String(uri).match(myregexp);
     iTrustPage.getMemoryCachedReportLastUri = uri;
     
     
     var mangledUri;      
     
     if (RegDomain[4])
        mangledUri = RegDomain[2]+"://"+RegDomain[4]+RegDomain[5];
     else
        mangledUri = "internal://"+RegDomain[2]+":"+RegDomain[5];
        
     // make a cache for this regular expression.	
     iTrustPage.getMemoryCachedReportMangledUri = mangledUri;
     return iTrustPage.trustReportCache[mangledUri];  	 
     
     
  },
  setMemoryCachedReport: function(rpt){        
     // Add cleanup to the in-memory cache.
     if (iTrustPage.trustReportCache[rpt.uri]){
        delete iTrustPage.trustReportCache[rpt.uri];
     }else{       
        iTrustPage.trustReportCacheEntries.push(rpt.uri);
     }
     
//     alert (iTrustPage.trustReportCacheEntries.length);
     
     if (iTrustPage.trustReportCacheEntries.length > iTrustPage.trustReportCacheMax){
         var toRemove = iTrustPage.trustReportCacheEntries.shift();
//         alert ("removing " + toRemove);
         delete iTrustPage.trustReportCache[toRemove];
     }
  
     iTrustPage.trustReportCache[rpt.uri] = rpt.clone(false);;  	  
  },
  getUriReport: function(uri,trackingOnly) {
     var trustReport;

     trustReport = this.getMemoryCachedReport(uri);
     // check if we already have a report object stored
     if (trustReport){
        if (!this.trustReportTab[getBrowser().mTabContainer.selectedIndex] ||
            this.trustReportTab[getBrowser().mTabContainer.selectedIndex].uri !=
            trustReport.uri){    
     
	         //   alert ("cloning");
      	     trustReport = trustReport.clone(false);
      	     
      	     if (this.trustReportTab[getBrowser().mTabContainer.selectedIndex])
      	        delete this.trustReportTab[getBrowser().mTabContainer.selectedIndex];
      	     
              this.trustReportTab[getBrowser().mTabContainer.selectedIndex] = trustReport;	     
        }else{
           // see if we have information about this tab... * this gets called a lot *
	       //     alert ("cache1"); 
           trustReport = this.trustReportTab[getBrowser().mTabContainer.selectedIndex];
        }
        

     }else{
        // see if we have information about this tab.
	    //        alert ("cache2");
        trustReport = this.trustReportTab[getBrowser().mTabContainer.selectedIndex];     
     }     
          
     // no? create a new report. 
     if (!trustReport){
	    //        alert ("new report");
	    
 	    if (this.trustReportTab[getBrowser().mTabContainer.selectedIndex])
      	   delete this.trustReportTab[getBrowser().mTabContainer.selectedIndex];
	    
        this.trustReportTab[getBrowser().mTabContainer.selectedIndex] 
           = new TrustReport();
        trustReport = this.trustReportTab[getBrowser().mTabContainer.selectedIndex];        
     }

     trustReport.setURI(uri,trackingOnly);
     if (!trackingOnly){
	    if (!trustReport.trusted && trustReport.currentURI != trustReport.firstDomainURI){
           var trustReportCurrentURI = new TrustReport();
           trustReportCurrentURI.setURI(uri,trackingOnly);	   
            
           if (trustReportCurrentURI.trusted){
      	     if (this.trustReportTab[getBrowser().mTabContainer.selectedIndex])
      	        delete this.trustReportTab[getBrowser().mTabContainer.selectedIndex];
      	        
              this.trustReportTab[getBrowser().mTabContainer.selectedIndex] 
                  = trustReportCurrentURI;
              trustReport = trustReportCurrentURI;        
	           
           }              
	    }    	     
     }     
     
     return trustReport;
  },  
  updateNotificationBar: function (force){
 	 var rpt = iTrustPage.getCurrentReport();     

 	 // show bottom yellow bar
     var msgText = rpt.getNotificationMessage();    
     if (iTrustPageMain.debugLevel == 2)
        msgText += "; trackingOnly: "+trackingOnly;
       
     if (force || iTrustPage.msgText != msgText)
        iTrustPageMain.notificationShow(msgText);	  
              
     iTrustPage.msgText = msgText;    
  },
  onInputFocus: function (ev){	  
	  //alert("?");
	  var key = ev.target.id+","+ev.target.name+","+ev.target.parentNode.tagName+","+ev.target.parentNode.id;
//	  alert(key);
	  
	  if (iTrustPage.InputWithFocus != key){
	     iTrustPage.InputWithFocus = key;
	     iTrustPage.InputWithFocusCount = 0;
      }
      iTrustPage.InputWithFocusCount += 1;

      //if (!iTrustPage.InputHasFocus){
	     iTrustPage.InputHasFocus=true;	  
	     iTrustPage.updateStatusbar();
	     
// 	 var rpt = iTrustPage.getCurrentReport();     
	     iTrustPageLog.appendInputFocusEvent();
      //}
     //rpt.InputHasFocus = iTrustPage.InputHasFocus;
     //rpt.InputWithFocus = ev.target;
  },
  onInputBlur: function (ev){
	  var key = ev.target.id+","+ev.target.name+","+ev.target.parentNode.tagName+","+ev.target.parentNode.id;
	  
	  if (iTrustPage.InputWithFocus != key){
	     iTrustPage.InputWithFocus = key;
	     iTrustPage.InputWithFocusCount = 0;
      }
      
	  iTrustPage.InputWithFocusCount -= 1;	            
 	 //var rpt = iTrustPage.getCurrentReport();     
	     iTrustPageLog.appendInputBlurEvent();
     
     //alert (iTrustPage.InputWithFocusCount);
	  
	 //if (iTrustPage.InputHasFocus && iTrustPage.InputWithFocusCount <= 0){
     //alert ("blur"+iTrustPage.urlbarFocus);
     //if (!iTrustPage.urlbarFocus){
        iTrustPage.InputHasFocus=false;	  	  
        iTrustPage.updateStatusbar();
     //}
     //}
     //rpt.InputHasFocus = iTrustPage.InputHasFocus;
     //rpt.InputWithFocus = ev.target;
  },	  
  clearURLBarColor: function (){
	  
     //var urlbar = document.getElementById("urlbar");
     //var urlbar_container = document.getElementById("urlbar-container");
     
	            //alert ("a");
	            if (iTrustPage.OriginalURLBarBgcolor  != "")
	            {	              		           
		          //  alert (iTrustPage.OriginalURLBarBgcolor);          		           
		            
		           /* firefox bug workaround */ 
		           iTrustPage.urlbar.style.backgroundColor =  "";
		           var urlbar_style = iTrustPage.urlbar.getAttribute("style");
                   iTrustPage.urlbar.setAttribute("style",urlbar_style+";background-color:"+iTrustPage.OriginalURLBarBgcolor);		            
		           iTrustPage.urlbar.style.backgroundColor =  "";
                   
	               iTrustPage.OriginalURLBarBgcolor = ""; 
                }
	  
	            //alert ("b");
	            if (iTrustPage.OriginalURLBarContainerBgcolor  != ""){	    
		           // alert (iTrustPage.OriginalURLBarContainerBgcolor);          		           
		            
		           /* firefox bug workaround */ 
		           iTrustPage.urlbar_container.style.backgroundColor =  "";
		           var urlbar_container_style = iTrustPage.urlbar_container.getAttribute("style");
                   iTrustPage.urlbar_container.setAttribute("style",urlbar_container_style+";background-color:"+iTrustPage.OriginalURLBarContainerBgcolor);		            

		           var urlbar_container_style = iTrustPage.urlbar_container.getAttribute("style");
	               
                   //alert (urlbar_container_style);
                   	               
	               iTrustPage.OriginalURLBarContainerBgcolor = ""; 
                }

                if (iTrustPage.OriginalURLBarFontWeight  != ""){	              		           
		            
		           /* firefox bug workaround */ 
		           iTrustPage.urlbar.style.fontWeight =  iTrustPage.OriginalURLBarFontWeight;
		           var urlbar_style = iTrustPage.urlbar_container.getAttribute("style");
                   iTrustPage.urlbar.setAttribute("style",urlbar_style+";font-weight:"+iTrustPage.OriginalURLBarFontWeight);		            
	               
	               iTrustPage.OriginalURLBarFontWeight = ""; 
                }
  },
  
  updateStatusbar: function (){
 	 var rpt = iTrustPage.getCurrentReport();     

     // set colors of statusbar indicator
    // var statusbar = document.getElementById("itrustpage-status-bar");
     //var urlbar = document.getElementById("urlbar");
     //var urlbar_container = document.getElementById("urlbar-container");
     
     var itrustpage_logo = document.getElementById("itrustpage-logo");
     var itrustpage_ver_logo = document.getElementById("itrustpage-ver-logo");
     //var urlbar_itrustpage = document.getElementById("urlbar-itrustpage");
     
     var trustmenu_validate = document.getElementById("trustmenu-validate");
     var trustmenu_validate_sep = document.getElementById("trustmenu-validate-sep");
     
     //var urlbar_style = urlbar.getAttribute("style");
     //urlbar.setAttribute("style",urlbar_style+";background-color: orange");
     //alert (itrustpage_logo.style.height + ","+ itrustpage_logo.width);
   //  alert ("updateStatusbar");
     
     if (iTrustPage.InputHasFocus || rpt.blockShowing){
         //alert ("iTrustPage.InputHasFocus || rpt.blockShowing");
         iTrustPage.shownIcon = true;
	     iTrustPage.urlbar_itrustpage.collapsed = false;
         
     }else{
         //alert ("else iTrustPage.InputHasFocus || rpt.blockShowing");
         iTrustPage.urlbar_itrustpage.collapsed=true;
         //alert ("done collapse");
         iTrustPage.clearURLBarColor();
         
         
     }
     //alert ("done");
     
     
     
     if (iTrustPage.InputHasFocus && rpt.checked_full){
        iTrustPage.shownIcon = true;
        //window.clearTimeout(iTrustPage.iTrustPageStatusBarUpdate);          
	     
	           //alert("in iTrustPage.InputHasFocus && rpt.checked_full");
        if (rpt.trusted){
           if (rpt.nonhttp){
      //        statusbar.collapsed = true;                      
           }
           else if (rpt.service_trust){
	           itrustpage_ver_logo.src="chrome://itrustpage/skin/itp_verified_small.gif";
               itrustpage_ver_logo.tooltipText = "This page is verified";

               iTrustPage.clearURLBarColor();
	               
                trustmenu_validate.collapsed=true;
                trustmenu_validate_sep.collapsed=true;
              
           }else{
	           if (rpt.found){
   	              itrustpage_ver_logo.src="chrome://itrustpage/skin/itp_verified_small.gif";
                  itrustpage_ver_logo.tooltipText = "This page is verified";
	           } else {
	              itrustpage_ver_logo.src="chrome://itrustpage/skin/itp_unverified_small.gif";
                  itrustpage_ver_logo.tooltipText = "This page is unverified";
	           }

               iTrustPage.clearURLBarColor();
/*	           
	           
	            itrustpage_ver_logo.src="chrome://itrustpage/skin/itp-logo-questionmark.gif";

	            if (iTrustPage.OriginalURLBarBgcolor != ""){
		            
		            
		           urlbar.style.backgroundColor =  "";
		           var urlbar_style = urlbar.getAttribute("style");
                   urlbar.setAttribute("style",urlbar_style+";"+iTrustPage.OriginalURLBarBgcolor);		            
	               
	               iTrustPage.OriginalURLBarBgcolor = "";
                }
*/
	           
                trustmenu_validate.collapsed=false;
                trustmenu_validate_sep.collapsed=false;
              
           }
        } else {
	       itrustpage_ver_logo.src="chrome://itrustpage/skin/itp_unverified_small.gif";
           itrustpage_ver_logo.tooltipText = "This page is unverified";
	       
              //alert (iTrustPage.InputHasFocus);
	       if (iTrustPage.InputHasFocus){
		      
		      if (iTrustPage.OriginalURLBarBgcolor == "")
                 iTrustPage.OriginalURLBarBgcolor = iTrustPage.urlbar.style.backgroundColor;
                 
              if (iTrustPage.OriginalURLBarBgcolor == "") iTrustPage.OriginalURLBarBgcolor="undefined";
              iTrustPage.urlbar.style.backgroundColor = "#ffe1cf";
              
		      if (iTrustPage.OriginalURLBarFontWeight == "")
                 iTrustPage.OriginalURLBarFontWeight = iTrustPage.urlbar.style.fontWeight;
              if (iTrustPage.OriginalURLBarFontWeight == "") iTrustPage.OriginalURLBarFontWeight="undefined";
              iTrustPage.urlbar.style.fontWeight = "bold";
              
              //alert ("A");
              
		      if (iTrustPage.OriginalURLBarContainerBgcolor == "")
                 iTrustPage.OriginalURLBarContainerBgcolor = iTrustPage.urlbar_container.style.backgroundColor;
              if (iTrustPage.OriginalURLBarContainerBgcolor == "") iTrustPage.OriginalURLBarContainerBgcolor="undefined";
              iTrustPage.urlbar_container.style.backgroundColor = "#ffd200";
              //alert ("B");
           }
           trustmenu_validate.collapsed=false;
           trustmenu_validate_sep.collapsed=false;
	        
           

        }        
     }else{
     }
     
	  
  },
  BrowserBack: function (aEvent, aIgnoreAlt){
 	 var rpt = iTrustPage.getCurrentReport();     
 	 iTrustPageLog.appendEventBrowserBack(rpt);
     if (rpt.blockShowing){
        var searchBox = document.getElementById("itrustpage-block-search-box");  
        var boxFound = document.getElementById("TrustBlock-found-box");
        var boxVerify = document.getElementById("TrustBlock-verify-box");
        var boxVerifyAuto = document.getElementById("TrustBlock-verify-box-auto");
        var boxIgnore = document.getElementById("TrustBlock-ignore-box");
        
        if (!searchBox.collapsed){	     
	       TrustBlock.hideBlock();    	   
        }else if (!boxVerify.collapsed){
		    boxFound.collapsed=false;
		    boxVerifyAuto.collapsed=true;
		    boxVerify.collapsed=true;
		    boxIgnore.collapsed=true;
           iTrustPage.InputHasFocus=true;	  
        	 iTrustPage.updateStatusbar();
        	 
        	 
          var b = iTrustPage.getCurrentBrowser();
          var uri = String(b.contentDocument.location);
   	      //var urlbar = document.getElementById("urlbar");
   	      iTrustPage.urlbar.value = uri;

            TrustBlock.doSearch();            
//            var itrustpage_ver_logo = document.getElementById("itrustpage-ver-logo");
//            itrustpage_ver_logo.src="chrome://itrustpage/skin/itp_unverified_small.gif";
            
        }else{
		    searchBox.collapsed=false;   
		    boxFound.collapsed=true;
		    boxVerifyAuto.collapsed=true;
		    boxVerify.collapsed=true;
		    boxIgnore.collapsed=true;
	    }
     }else{ 	  		     
        iTrustPage_BrowserBack(aEvent, aIgnoreAlt); 	
//  	    iTrustPage.doWindowContentDocumentActions();
        
     }
  },   
  BrowserForward: function (aEvent, aIgnoreAlt){
 	 var rpt = iTrustPage.getCurrentReport();     
 	 iTrustPageLog.appendEventBrowserForward(rpt);
 	 
     iTrustPage_BrowserForward(aEvent, aIgnoreAlt); 	
 //    iTrustPage.doWindowContentDocumentActions();
  },
  BrowserOpenBookmark: function (aSelection, aTargetBrowser, aDS){
     //alert (iTrustPage_BrowserOpenBookmark);
 	 var rpt = iTrustPage.getCurrentReport();     
 	 iTrustPageLog.appendEventBrowserBookmarkOpen(rpt);     
     
     BookmarksCommand.iTrustPage_BrowserOpenBookmark (aSelection, aTargetBrowser, aDS);	  
  },
  
  doTrustCheck: function(uri,trackingOnly) {      
     rpt = this.getUriReport(uri,trackingOnly);      
          
     if (!trackingOnly){
        // check results and redirect to user-interface
        if (rpt.trusted == false)
           TrustBlock.showBlock();
        else
           TrustBlock.hideBlock();
     }else{
           //TrustBlock.hideBlock();     
     }

     //iTrustPage.updateStatusbar();                 
     return rpt;
  },  
  onPageHide: function (e) {    
	  if (iTrustPage.uri_typed_keys > 0)
	     iTrustPageLog.appendEventFormTypedAllCount    (rpt,iTrustPage.uri_typed_keys);
	       
      iTrustPage.uri_typed_keys=0;
	  
      //TrustBlock.hideBlockSmallDelay();     
	  // gmail screws this up:
//     var statusbar = document.getElementById("itrustpage-status-bar");
//     statusbar.collapsed = true;	  
  },

  addDocumentContentEventListeners: function(e){
     
     /* XXX: Maybe keypress doesn't work inside an iframe?? But it does... so wierd*/
     
     window.content.document.addEventListener("keypress",function (event) {iTrustPage.onKeyboardEvent(event,false)},true);
     window.content.document.addEventListener("input",function (event) {iTrustPage.onInputEvent(event,false)},true);
     
     
     //alert("done");
  
  },  
  addContentEventListeners: function(e){
/*     for (var i=0;i<getBrowser().mTabContainer.childNodes.length; ++i){
        var b = getBrowser().getBrowserAtIndex(i);
   	     
        if (b.contentDocument == e.target)
           break;
     }
     if (i == getBrowser().mTabContainer.childNodes.length)
        return;     

     var b = getBrowser().getBrowserAtIndex(i);*/
     var b = iTrustPage.getCurrentBrowserTarget(e.target);
     

     
     /* XXX: Maybe keypress doesn't work inside an iframe?? But it does... so wierd*/
     
     //b.addEventListener("focus",iTrustPage.onDocumentFocus,true);
     b.addEventListener("keypress",function (event) {iTrustPage.onKeyboardEvent(event,true)},true);
     b.addEventListener("input",function (event) {iTrustPage.onInputEvent(event,true)},true);
     
     //b.addEventListener("blur",iTrustPage.onDocumentBlur,true);
  
  },  
  onTabSelected: function (e) {	  
     iTrustPage.InputHasFocus=false;	  	  
	       
	  //alert ("onTabSelected");
//     var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
     var b = iTrustPage.getCurrentBrowserTarget(e.target);

     var uri = String(b.contentDocument.location);
     rpt = iTrustPage.trustReportTab[getBrowser().mTabContainer.selectedIndex];

     // if the currently loaded report matches the tab then follow its directions
     if (rpt && uri == rpt.currentURI && rpt.blockShowing){
        iTrustPage.checkCurrentUri (false);
        var cmd_back = document.getElementById("Browser:Back");
        cmd_back.removeAttribute("disabled");     
     //}else if (rpt){
       /* if (!rpt.InputHasFocus)     
    	    iTrustPage.onInputBlur(e);
 	    else{
 	       iTrustPage.onInputFocus(e);
 	       //alert(rpt.InputWithFocus);
           //rpt.InputWithFocus.focus();
	    }*/
	     
     }else{
        iTrustPage.checkCurrentUri (true);
     }
     
     //var rpt = iTrustPage.getCurrentReport();        
 	 iTrustPage.updateStatusbar();


  }
};

/* from: http://brianary.blogspot.com/2006/08/firefox-using-nsiwebprogresslistener.html */
var iTrustPage_progressListener = {         
	stateIsRequest:false,        
	QueryInterface : function(aIID) {            
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||                
		aIID.equals(Components.interfaces.nsISupportsWeakReference) ||                
		aIID.equals(Components.interfaces.nsISupports))                    
		return this;            
		throw Components.results.NS_NOINTERFACE;        
	},        
	onStateChange : function(aProgress,aRequest,aFlag,aStatus) {iTrustPage.onStateChange(aProgress,aRequest,aFlag,aStatus); return 0;},        
	onLocationChange : function(aProgress,aRequest,aLocation) {            
		iTrustPage.onLocationChange(aProgress,aRequest,aLocation);
		return 0;        
 	},        
	onProgressChange : function(a,b,c,d,e,f){ iTrustPage.onProgressChange(a,b,c,d,e,f); },        
	onStatusChange : function(a,b,c,d){ TrustPage.onStatusChange(a,b,c,d); },        
	onSecurityChange : function(a,b,c){ TrustPage.onSecurityChange(a,b,c); },        
	onLinkIconAvailable : function(a){}     
};
 
// Add hooks so that our class gets called.
window.addEventListener("load", function(e) { iTrustPage.onLoad(e); }, false); 




/* replace the browser back function */
//alert(typeof(iTrustPage_BrowserBack));
if (typeof(iTrustPage_BrowserBack) == "undefined"){
   iTrustPage_BrowserBack = BrowserBack;
}
BrowserBack = iTrustPage.BrowserBack;

/* replace the browser forward function */
if (typeof(iTrustPage_BrowserForward) == "undefined"){
   iTrustPage_BrowserForward = BrowserForward;
}
BrowserForward = iTrustPage.BrowserForward;

/* replace the bookmark open function */
if (typeof(BookmarksCommand.iTrustPage_BrowserOpenBookmark) == "undefined"){
   BookmarksCommand.iTrustPage_BrowserOpenBookmark = BookmarksCommand.openBookmark;
}
BookmarksCommand.openBookmark = iTrustPage.BrowserOpenBookmark;

